unit afine;

Interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs;


procedure afine_mat;
(*procedure afine_distance(var distance_min:real);*)

implementation
{R+}

uses
  oemath, stdhdr, matmath;

{angle de 2 vecteurs en coordonnees ortho.}
function ang1(var x,y: vecteur3): real;{
---------------------------------------}
var
  d1   : real;
begin
  D1:=SQRT( (x[1]*x[1]+x[2]*x[2]+x[3]*x[3])*(y[1]*y[1]+Y[2]*Y[2]+Y[3]*Y[3]) );
  ang1:=arcos((x[1]*y[1]+x[2]*y[2]+x[3]*y[3])/d1);
end;

function ang( var x1,y1,z1,x2,y2,z2:real): real;{
-----------------------------------------------}
var
x,y           : vecteur3;
begin
      x[1]:=x1 ;
      x[2]:=y1 ;
      x[3]:=z1 ;
      y[1]:=x2 ;
      y[2]:=y2 ;
      y[3]:=z2 ;
      ang:=ang1(x,y)
 end;

procedure afine_mat;{
--------------------}
var
      q                                             : array[1..30,1..4] of real;
      axe                                           : vecteur3;
      matcor,aux,ma,mb,mc                           : matrice3;
      xo1,xo2,xo3,xo4,xc1,xc2,xc3                   : vecteur3;
      x3c,y3c,z3c                                   : array[1..30] of real;

      vecteur                                       : vecteur3;
      xf,yf,res1                                    : real;

      xh,xk,xl,xx,yy,zz,xx3c,yy3c,zz3c,alphac       : real;
      an1,an2,an3,fa,co,si,unco,s,distance_min      : real;
      nn,itour,i,j,k,l,m                            : integer;

      nomf                                          : TextFile;

      {Variables pour la regression}
      tableauq                       : recmat;
      y_obs,coef_calc                : LongVector;

begin
{Vecteurs calculs dans l'espace 2}
      xh:=ishkl[no_sol,n1,1];
      xk:=ishkl[no_sol,n1,2];
      xl:=ishkl[no_sol,n1,3];
      trfo(xh,xk,xl,xc1[1],xc1[2],xc1[3],r21);
      norm3(xc1);
      xh:=ishkl[no_sol,n2,1];
      xk:=ishkl[no_sol,n2,2];
      xl:=ishkl[no_sol,n2,3];
      trfo(xh,xk,xl,xc2[1],xc2[2],xc2[3],r21);
      norm3(xc2);

{Angle de ces 2 vecteurs}
      alphac:=ang1(xc1,xc2);

{3me axe}
      prodvec(xc1,xc2,xc3);
      norm3(xc3);

{Vecteurs observs dans l'espace 3}
      xo1[1]:=x3o[n1];
      xo1[2]:=y3o[n1];
      xo1[3]:=z3o[n1];
      xo2[1]:=x3o[n2];
      xo2[2]:=y3o[n2];
      xo2[3]:=z3o[n2];

{3me axe}
      prodvec(xo1,xo2,xo3);
      norm3(xo3);

{Correction du 2me axe}
      co:=cos(alphac);
      si:=sin(alphac);
      unco:=1.-co;
      aux[1,1]:=co+xo3[1]*xo3[1]*unco;
      aux[2,1]:=xo3[1]*xo3[2]*unco+xo3[3]*si;
      aux[3,1]:=xo3[3]*xo3[1]*unco-xo3[2]*si;
      aux[1,2]:=xo3[1]*xo3[2]*unco-xo3[3]*si;
      aux[2,2]:=co+xo3[2]*xo3[2]*unco;
      aux[3,2]:=xo3[2]*xo3[3]*unco+xo3[1]*si;
      aux[1,3]:=xo3[3]*xo3[1]*unco+xo3[2]*si;
      aux[2,3]:=xo3[2]*xo3[3]*unco-xo3[1]*si;
      aux[3,3]:=co+xo3[3]*xo3[3]*unco;
      trfo4(xo1,xo4,aux);

{Dtermination de la matrice r23 de dpart}
      for i:=1 to 3 do begin
        ma[i,1]:=xc1[i];
        ma[i,2]:=xc2[i];
        ma[i,3]:=xc3[i];
        mb[i,1]:=xo1[i];
        mb[i,2]:=xo2[i];
        mb[i,3]:=xo3[i];
      end;
      matinv(mb,mc);
      mat_mult(ma,mc,r23);
      trspo2(r23,r32);

{Dtermination d'une matrice approche (matrice de rotation)}
      for i:=1 to 3 do begin
        ma[i,1]:=xc1[i];
        ma[i,2]:=xc2[i];
        ma[i,3]:=xc3[i];
        mb[i,1]:=xo1[i];
        mb[i,2]:=xo4[i];
        mb[i,3]:=xo3[i];
      end;
      matinv(mb,mc);
      mat_mult(ma,mc,r23);
      trspo2(r23,r32);
      mat_mult(r32,r21,r31);

      for itour:=1 to 2 do begin

{Calcul des cosinus directeurs des vecteurs calculs dans l'espace 3}
        for i:=1 to nobs+ns do begin
          if(i <= nobs)then begin
            xx:=ishkl[no_sol,i,1];
            yy:=ishkl[no_sol,i,2];
            zz:=ishkl[no_sol,i,3];
          end else begin
            j:=i-nobs;
            xx:=h_sup[j];
            yy:=k_sup[j];
            zz:=l_sup[j];
          end;
          trfo(xx,yy,zz,x3c[i],y3c[i],z3c[i],r31);
          norm(x3c[i],y3c[i],z3c[i]);
        end;

{dtermination de la matrice de correction approximative}
        nn:=0;
        for i:=1 to nobs+ns do begin
          nn:=nn+1;
          q[nn,1]:=0;
          q[nn,2]:=-z3c[i];
          q[nn,3]:=y3c[i];
          q[nn,4]:=x3o[i]-x3c[i];
          nn:=nn+1;
          q[nn,1]:=z3c[i];
          q[nn,2]:=0;
          q[nn,3]:=-x3c[i];
          q[nn,4]:=y3o[i]-y3c[i];
          nn:=nn+1;
          q[nn,1]:=-y3c[i];
          q[nn,2]:=x3c[i];
          q[nn,3]:=0;
          q[nn,4]:=z3o[i]-z3c[i];
        end;
{----------------------Affinement par MCRL dans matmath------------------------}
        m:=nn;
        l:=3;
        for i:=0 to l-1 do
          for j:= 0 to m-1 do tableauq[i,j]:=q[j+1,i+1];
        for i:=0 to m-1 do y_obs[i]:=q[i+1,4];
        MCRL(tableauq,y_obs,l,m,coef_calc);
 {-----------------------------------------------------------------------------}
        for j:=1 to 3 do begin
          axe[j]:=coef_calc[j-1];
        end;
        xx:=axe[1];
        yy:=axe[2];
        zz:=axe[3];
        norm(axe[1],axe[2],axe[3]);
        an1:=xx/axe[1];
        an2:=yy/axe[2];
        an3:=zz/axe[3];

{Matrice de correction (et de rotation)}
        fa:=an1;
        co:=cos(fa);
        si:=sin(fa);
        unco:=1.-co;
        matcor[1,1]:=co+axe[1]*axe[1]*unco;
        matcor[1,2]:=axe[1]*axe[2]*unco+axe[3]*si;
        matcor[1,3]:=axe[3]*axe[1]*unco-axe[2]*si;
        matcor[2,1]:=axe[1]*axe[2]*unco-axe[3]*si;
        matcor[2,2]:=co+axe[2]*axe[2]*unco;
        matcor[2,3]:=axe[2]*axe[3]*unco+axe[1]*si;
        matcor[3,1]:=axe[3]*axe[1]*unco+axe[2]*si;
        matcor[3,2]:=axe[2]*axe[3]*unco-axe[1]*si;
        matcor[3,3]:=co+axe[3]*axe[3]*unco;

{la matrice r32 ancienne est corrige}
        mat_mult(matcor,r32,aux);
        ident(aux,r32);
        trspo2(r32,r23);
        mat_mult(r32,r21,r31);
        mat_mult(r12,r23,r13);
     end;
   end;

(*procedure afine_distance(var distance_min:real);{
------------------------------------------------}
var
   i,j                             : integer;
   xx,yy,zz,x3,y3,z3,xf,yf,wl,vv   : real;
   delta_dist,res_min              : real;
   d,res                           : array[-10..10] of real;
   nomf                            : textfile;
 begin
    delta_dist:=distance*0.001;
    res_min:=100000;
    distance_min:=distance;
    for j:=-10 to 10 do begin
      d[j]:=distance+delta_dist*j;
      res[j]:=0;
      for i:=1 to nobs do begin
        xx:=ishkl[no_sol,i,1];
        yy:=ishkl[no_sol,i,2];
        zz:=ishkl[no_sol,i,3];
        trfo(xx,yy,zz,x3,y3,z3,r31);
        wl:=2*x3/(x3*x3+y3*y3+z3*z3);
        vv:=-d[j]/(x3*wl-1);
        xf:=vv*wl*y3;
        yf:=vv*wl*z3;
        res[j]:=res[j]+sqr(xf-xobs[i])+sqr(yf-yobs[i]);
      end;
      res[j]:=res[j]/nobs;
      if(res_min > res[j]) then begin
        res_min:=res[j];
        distance_min:=d[j];
      end;
    end;
    assignFile(nomf,'distance.txt');
    rewrite(nomf);
    for j:=-10 to 10 do writeln(nomf,d[j]:10:3,res[j]:12:5);
    closefile(nomf);
end;    *)

end.
