
Unit index;

Interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

procedure Lauindex;

implementation
{R+}

uses
  oemath,afine;
var
  xyzo                                    : array[1..30,1..3] of real;
  xyzc1,xyzc2,ahkl1,ahkl2                 : array[1..2000,1..3] of real;
  nv1,nv2                                 : integer;
  a1,ca1,sa1,r1_min                       : real;

 Procedure existe_raie(var ah,ak,al: real; var num_raie,ier: integer);{
 ---------------------------------------------------------------------}
  var
    i,ih,ik,il,iext,n                                      : integer;
    r2hkl,wl,lambda                                        : real;
    x3,y3,z3,x3p,y3p,z3p,xx4,yy4,zz4,xf,yf,vv              : real;
  begin
     ier:=1;
     x3:=r31[1,1]*ah+r31[1,2]*ak+r31[1,3]*al;
     if (x3 < 0.00001) then begin
       ier:=1;
       exit;
     end;
     y3:=r31[2,1]*ah+r31[2,2]*ak+r31[2,3]*al;
     z3:=r31[3,1]*ah+r31[3,2]*ak+r31[3,3]*al;
     r2hkl:=x3*x3+y3*y3+z3*z3;

{La famille de plans peut-elle rflechir dans l'intervalle lambda_min-lambda_max?}
     wl:=2*x3/r2hkl;
     if(wl < lambda_min)then begin
       ier:=1;
       exit;
     end;
     n:=1+round(wl/lambda_min);
     iext:=0;
     for i:=1 to n do begin
        lambda:=wl/i;
        if(lambda > lambda_max)then continue;
        if(lambda < lambda_min)then begin
          ier:=1;
          exit;
        end;
        ih:=round(ah*i);
        ik:=round(ak*i);
        il:=round(al*i);
        extinc(ih,ik,il,iext);
        if(iext <> 0) then continue;

        {la rflexion est possible: Cacul de xf et yf}
         x3p:=x3*wl-1;
         y3p:=y3*wl;
         z3p:=z3*wl;
         xx4:=x3p*codelta-y3p*sidelta;
         yy4:=x3p*sidelta+y3p*codelta;
         zz4:=z3p;
         if (geom = 'CYL') then begin
           xf:=distance*atan2(-yy4,xx4);
           yf:=zz4*distance/sqrt(xx4*xx4+yy4*yy4);
         end else begin
           vv:=distance/xx4;
           xf:=-vv*yy4;
           yf:=vv*zz4;
         end;
         if (sqrt(sqr(xf-xobs[num_raie])+sqr(yf-yobs[num_raie]))<0.5)then begin
           ier:=0;
           exit;
         end else begin
           ier:=1;
         end;
     end;
  end;

{Calcul des cos. direct. des vecteurs-diffusion des taches mesures}
Procedure XYz;{
--------------}
  var
     i               : integer;
     v3              : vecteur3;
  begin
      if (geom = 'CYL') then begin
        for i:=1 to nobs do begin
          trlnc(xobs[i],yobs[i],v3);
          x3o[i]:=v3[1];
          y3o[i]:=v3[2];
          z3o[i]:=v3[3];
          xyzo[i,1]:=x3o[i];
          xyzo[i,2]:=y3o[i];
          xyzo[i,3]:=z3o[i];
        end;
      end else begin
        for i:=1 to nobs do begin
          trln(xobs[i],yobs[i],v3);
          x3o[i]:=v3[1];
          y3o[i]:=v3[2];
          z3o[i]:=v3[3];
          xyzo[i,1]:=x3o[i];
          xyzo[i,2]:=y3o[i];
          xyzo[i,3]:=z3o[i];
        end;
      end;
   end;

procedure gener(var ier: integer);{
----------------------------------}
 var
    ih,ik,il,iu,iv,iw,ipgcd,iih,iik,iil,dif       : integer;
    j,i                                           : integer;
    xx,yy,zz,r                                    : real;
    h_eq,k_eq,l_eq                                : array[1..2,1..48] of integer;
    nb_eq1,nb_eq2                                 : integer;
    //nomf                                        : textfile;

 begin
   (* assignfile(nomf,'espion.txt');
    rewrite(nomf); *)

//Set No 1
  dif:=abs(h1_known)+abs(k1_known)+abs(l1_known);

//Les indices sont donns
  if (dif > 0)then begin
    for j:=1 to ndeg*2 do begin
      h_eq[1,j]:=it[1,1,j]*h1_known+it[1,2,j]*k1_known+it[1,3,j]*l1_known;
      k_eq[1,j]:=it[2,1,j]*h1_known+it[2,2,j]*k1_known+it[2,3,j]*l1_known;
      l_eq[1,j]:=it[3,1,j]*h1_known+it[3,2,j]*k1_known+it[3,3,j]*l1_known;
    end;

//Doubles
    for j:=1 to ndeg*2-1 do begin
       for i:=j+1 to ndeg*2 do begin
         if (h_eq[1,j] = h_eq[1,i]) and (k_eq[1,j] = k_eq[1,i])
         and(l_eq[1,j] = l_eq[1,i]) then begin
            h_eq[1,i]:=0;
            k_eq[1,i]:=0;
            l_eq[1,i]:=0;
         end;
       end;
    end;
    nb_eq1:=0;
    for i:=1 to ndeg*2 do begin
       if (h_eq[1,i] = 0) and (k_eq[1,i] = 0) and (l_eq[1,i] = 0) then continue;
       nb_eq1:=nb_eq1+1;
       h_eq[1,nb_eq1]:=h_eq[1,i];
       k_eq[1,nb_eq1]:=k_eq[1,i];
       l_eq[1,nb_eq1]:=l_eq[1,i];
    end;

    (*writeln(nomf,nb_eq1);
    for i:=1 to nb_eq1 do writeln(nomf,h_eq[1,i]:3,k_eq[1,i]:3,l_eq[1,i]:3);
    writeln(nomf);*)

    iu:=round(uvw[1]);
    iv:=round(uvw[2]);
    iw:=round(uvw[3]);
    nv1:=0;
    for i:=1 to nb_eq1 do begin
      ih:=h_eq[1,i];
      ik:=k_eq[1,i];
      il:=l_eq[1,i];
      if(ih = 0 ) and (ik = 0) and (il = 0) then continue;
      if((ih*iu+ik*iv+il*iw) <> 0)then continue;
      premier(ih,ik,il,iih,iik,iil,ipgcd);
      if (ipgcd <> 1)then continue;
      nv1:=nv1+1;
      if(nv1 > 1999)then begin
        ier:=1;
        exit;
      end;
      ahkl1[nv1,1]:=ih;
      ahkl1[nv1,2]:=ik;
      ahkl1[nv1,3]:=il;
      trfo(ahkl1[nv1,1],ahkl1[nv1,2],ahkl1[nv1,3],xx,yy,zz,r21);
      r:=sqrt(xx*xx+yy*yy+zz*zz);
      if(r <= 0 ) then begin
        nv1:=nv1-1;
        if(nv1 = 1999)then begin
          erreur('H k l limits too big!');
          exit;
        end;
      end else begin
        xyzc1[nv1,1]:=xx/r;
        xyzc1[nv1,2]:=yy/r;
        xyzc1[nv1,3]:=zz/r;
      end;
    end;

//Les bornes sont donnes
  end else begin
    ier:=0;
    nv1:=0;
    iu:=round(uvw[1]);
    iv:=round(uvw[2]);
    iw:=round(uvw[3]);
    for ih:=ih1 to ih2 do begin
      for ik:=ik1 to ik2 do begin
        for il:=il1 to il2 do begin
          if(ih = 0 ) and (ik = 0) and (il = 0) then continue;
          if((ih*iu+ik*iv+il*iw) <> 0)then continue;
          premier(ih,ik,il,iih,iik,iil,ipgcd);
          if (ipgcd <> 1)then continue;
          nv1:=nv1+1;
          if(nv1 > 1999)then begin
            ier:=1;
            exit;
          end;
          ahkl1[nv1,1]:=ih;
          ahkl1[nv1,2]:=ik;
          ahkl1[nv1,3]:=il;
          trfo(ahkl1[nv1,1],ahkl1[nv1,2],ahkl1[nv1,3],xx,yy,zz,r21);
          r:=sqrt(xx*xx+yy*yy+zz*zz);
          if(r <= 0 ) then begin
            nv1:=nv1-1;
            if(nv1 = 1999)then begin
              erreur('H k l limits too big!');
              exit;
            end;
          end else begin
            xyzc1[nv1,1]:=xx/r;
            xyzc1[nv1,2]:=yy/r;
            xyzc1[nv1,3]:=zz/r;
          end;
        end;
      end;
    end;
  end;

//Set No 2

  dif:=round(abs(h2_known)+abs(k2_known)+abs(l2_known));
  if (dif > 0)then begin
    for j:=1 to ndeg*2 do begin
      h_eq[2,j]:=it[1,1,j]*h2_known+it[1,2,j]*k2_known+it[1,3,j]*l2_known;
      k_eq[2,j]:=it[2,1,j]*h2_known+it[2,2,j]*k2_known+it[2,3,j]*l2_known;
      l_eq[2,j]:=it[3,1,j]*h2_known+it[3,2,j]*k2_known+it[3,3,j]*l2_known;
    end;

//Doubles
    for j:=1 to ndeg*2-1 do begin
       for i:=j+1 to ndeg*2 do begin
         if (h_eq[2,j] = h_eq[2,i]) and (k_eq[2,j] = k_eq[2,i])
         and(l_eq[2,j] = l_eq[2,i]) then begin
            h_eq[2,i]:=0;
            k_eq[2,i]:=0;
            l_eq[2,i]:=0;
         end;
       end;
    end;
    nb_eq2:=0;
    for i:=1 to ndeg*2 do begin
       if (h_eq[2,i] = 0) and (k_eq[2,i] = 0) and (l_eq[2,i] = 0) then continue;
       nb_eq2:=nb_eq2+1;
       h_eq[2,nb_eq2]:=h_eq[2,i];
       k_eq[2,nb_eq2]:=k_eq[2,i];
       l_eq[2,nb_eq2]:=l_eq[2,i];
    end;
    (*writeln(nomf,nb_eq2);
    for i:=1 to nb_eq2 do writeln(nomf,h_eq[2,i]:3,k_eq[2,i]:3,l_eq[2,i]:3);
    writeln(nomf); *)

    iu:=round(uvw[1]);
    iv:=round(uvw[2]);
    iw:=round(uvw[3]);
    nv2:=0;
    for i:=1 to nb_eq2 do begin
      ih:=h_eq[2,i];
      ik:=k_eq[2,i];
      il:=l_eq[2,i];
      if(ih = 0 ) and (ik = 0) and (il = 0) then continue;
      if((ih*iu+ik*iv+il*iw) <> 0)then continue;
      premier(ih,ik,il,iih,iik,iil,ipgcd);
      if (ipgcd <> 1)then continue;
      nv2:=nv2+1;
      if(nv2 > 1999)then begin
        ier:=1;
        exit;
      end;
      ahkl2[nv2,1]:=ih;
      ahkl2[nv2,2]:=ik;
      ahkl2[nv2,3]:=il;
      trfo(ahkl2[nv2,1],ahkl2[nv2,2],ahkl2[nv2,3],xx,yy,zz,r21);
      r:=sqrt(xx*xx+yy*yy+zz*zz);
      if(r <= 0 ) then begin
        nv2:=nv2-1;
        if(nv2 = 1999)then begin
          erreur('H k l limits too big!');
          exit;
        end;
      end else begin
        xyzc2[nv2,1]:=xx/r;
        xyzc2[nv2,2]:=yy/r;
        xyzc2[nv2,3]:=zz/r;
      end;
    end;
  end else begin
    ier:=0;
     nv2:=0;
     for ih:=jh1 to jh2 do begin
       for ik:=jk1 to jk2 do begin
         for il:=jl1 to jl2 do begin
            if (ih = 0) and (ik = 0) and (il = 0)then continue;
            if ((ih*iu+ik*iv+il*iw) <> 0) then continue;
            premier(ih,ik,il,iih,iik,iil,ipgcd);
            if(ipgcd <> 1)then continue;
            nv2:=nv2+1;
            if (nv2 > 1999) then begin
              ier:=1;
              exit;
            end;
            ahkl2[nv2,1]:=ih;
            ahkl2[nv2,2]:=ik;
            ahkl2[nv2,3]:=il;
            trfo(ahkl2[nv2,1],ahkl2[nv2,2],ahkl2[nv2,3],xx,yy,zz,r21);
            r:=sqrt(xx*xx+yy*yy+zz*zz);
            if (r <= 0) then begin
              nv2:=nv2-1;
              if(nv2 = 1999)then begin
                erreur('H k l limits too big!');
                exit;
              end;
            end else begin
              xyzc2[nv2,1]:=xx/r;
              xyzc2[nv2,2]:=yy/r;
              xyzc2[nv2,3]:=zz/r;
            end;
         end;
       end;
     end;
  end;
  (*writeln(nomf);
  for i:=1 to nv1 do writeln(nomf,ahkl1[i,1]:3:0,ahkl1[i,2]:3:0,ahkl1[i,3]:3:0);
  writeln(nomf);
  for i:=1 to nv2 do writeln(nomf,ahkl2[i,1]:3:0,ahkl2[i,2]:3:0,ahkl2[i,3]:3:0);
  closefile(nomf); *)
end;

{Recherche du vecteur rciproque proche du vecteur hh,hk,hl}
Procedure find_indic(var hh,hk,hl,eh,ek,el: real; var num_raie,ilime,ier: integer);
{---------------------------------------------------------------------------------}
var
  ilim,i,ih,ik,il                             : integer;
  x1,x2,x3,z1,z2,z3,dif,xmax                  : real;
begin
    eh:=0;
    ek:=0;
    el:=0;
    ilim:=ilime;
    x1:=hh;
    x2:=hk;
    x3:=hl;
    xmax:=abs(x1);
    if (xmax < abs(x2))then xmax:=abs(x2);
    if (xmax < abs(x3))then xmax:=abs(x3);
    x1:=x1/xmax;
    x2:=x2/xmax;
    x3:=x3/xmax;
    for i:=1 to ilim do begin
      z1:=x1*i;
      z2:=x2*i;
      z3:=x3*i;
      ih:=round(z1);
      ik:=round(z2);
      il:=round(z3);
      eh:=ih;
      ek:=ik;
      el:=il;
      dif:=abs(eh-z1)+abs(ek-z2)+abs(el-z3);
      if (dif < 0.10) then begin
        ier:=0;
        existe_raie(eh,ek,el,num_raie,ier);
        exit;
      end;
    end;
    ier:=1;
end;

{Recherche les indices des taches de la solution ns1}
procedure indexe(var ns1,ier: integer);
{-------------------------------------}
  var
    i,ii,ilime                  : integer;
    xh,xk,xl,eh,ek,el           : real;
  begin
    for i:=1 to nobs  do begin
      trfo(x3o[i],y3o[i],z3o[i],xh,xk,xl,r13);
      ilime:=limite;
      ii:=i;
      find_indic(xh,xk,xl,eh,ek,el,ii,ilime,ier);
      if (ier = 1) then exit;
      ishkl[ns1,i,1]:=round(eh);
      ishkl[ns1,i,2]:=round(ek);
      ishkl[ns1,i,3]:=round(el);
    end;
    ier:=0;
  end;

{Dtermination de la matrice  partir de 2 taches}
Procedure ar23(var i1,i2,iermat: integer);
{----------------------------------------}
 var
    i                                                   : integer;
    xo1,xo2,xo3,xc1,xc2,xc3                             : vecteur3;
    a,b,c                                               : matrice3;
 begin
    iermat:=0;
    for i:=1 to 3 do begin
      xo1[i]:=xyzo[n1,i];
      xo2[i]:=xyzo[n2,i];
      xc1[i]:=xyzc1[i1,i];
      xc2[i]:=xyzc2[i2,i];
    end;
    prodvec(xo1,xo2,xo3);
    prodvec(xc1,xc2,xc3);
    norm(xo3[1],xo3[2],xo3[3]);
    norm(xc3[1],xc3[2],xc3[3]);
    for i:=1 to 3 do begin
      a[i,1]:=xc1[i];
      a[i,2]:=xc2[i];
      a[i,3]:=xc3[i];
      b[i,1]:=xo1[i];
      b[i,2]:=xo2[i];
      b[i,3]:=xo3[i];
    end;
    matinv(b,c);
    mat_mult(a,c,r23);
  end;


{calcul solution la + probable  1 seul rsidu: somme(indices**2)}
procedure calc_res(var sol:integer);
{---------------------------------}
  var
    j                 : integer;
    ah,ak,al          : real;
  begin
    residu_hkl[sol]:=0;
    for j:=1 to nobs do begin
      ah:=ishkl[sol,j,1];
      ak:=ishkl[sol,j,2];
      al:=ishkl[sol,j,3];
      residu_hkl[sol]:=residu_hkl[sol]+ah*ah+ak*ak+al*al;
    end;
    residu_hkl[sol]:=sqrt(residu_hkl[sol])/nobs;
  end;

{Elimination des solutions quivalentes.}
procedure equiv(var i1,i2,ier: integer);
{--------------------------------------}
  var
    h1,k1,l1,h2,k2,l2,jj,kk                : integer;
    i,j,k,ier1,ier2,is1,is2,is3            : integer;
    js1,js2,js3                            : integer;
    car                                    : char;
    nomf                                   : textfile;
begin
     h1:=round(ahkl1[i1,1]);
     k1:=round(ahkl1[i1,2]);
     l1:=round(ahkl1[i1,3]);
     h2:=round(ahkl2[i2,1]);
     k2:=round(ahkl2[i2,2]);
     l2:=round(ahkl2[i2,3]);
     ier:=1;
     ier1:=1;
     ier2:=1;
     ier:=1;
     for i:=1 to nsol do begin
       for j:=1 to ndeg*2 do begin
          is1:=it[1,1,j]*h1+it[1,2,j]*k1+it[1,3,j]*l1;
          is2:=it[2,1,j]*h1+it[2,2,j]*k1+it[2,3,j]*l1;
          is3:=it[3,1,j]*h1+it[3,2,j]*k1+it[3,3,j]*l1;
          js1:=it[1,1,j]*h2+it[1,2,j]*k2+it[1,3,j]*l2;
          js2:=it[2,1,j]*h2+it[2,2,j]*k2+it[2,3,j]*l2;
          js3:=it[3,1,j]*h2+it[3,2,j]*k2+it[3,3,j]*l2;
          if (is1 = ishkl[i,n1,1]) and (is2 = ishkl[i,n1,2]) and
             (is3 = ishkl[i,n1,3]) and (js1 = ishkl[i,n2,1]) and
             (js2 = ishkl[i,n2,2]) and (js3 = ishkl[i,n2,3]) then begin
            ier:=0;
            exit;
          end;
       end;
     end;
end;

{Produit scalaire de 2 vecteurs i et j(Vecteurs rciproques calculs)}
function ag(var i,j: integer): real;
{----------------------------------}
  var
  x1,x2,x3   : real;
  begin
    x1:=xyzc1[i,1]*xyzc2[j,1];
    x2:=xyzc1[i,2]*xyzc2[j,2];
    x3:=xyzc1[i,3]*xyzc2[j,3];
    ag:=x1+x2+x3;
  end;

{Recherche d'une solution d'indexation}
Procedure search(var ier: integer);
{---------------------------------}
var
   ier_equiv,ier_mat,i,j,ns1{,indh1,indk1,indl1,indh2,indk2,indl2 } : integer;
   ier_indexe,ii,jj                                                 : integer;
   dif,caij,dif1                                                    : real;
begin
    ier:=0;
    nsol:=0;

    for i:=1 to nv1 do begin
      ii:=i;
      for j:=1 to nv2 do begin
        dif:=abs(ahkl1[i,1]-ahkl2[j,1])+
        abs(ahkl1[i,2]-ahkl2[j,2])+abs(ahkl1[i,3]-ahkl2[j,3]);
        if(dif < 0.00001) then continue;
        jj:=j;
        caij:=ag(ii,jj);
        dif1:=abs(caij-ca1)/sa1;
        if(dif1 > eps) then continue;

        if(nsol > 0) then begin

   {-----------------------------------------------------------------}
          {if (systeme <> 'H') then begin}
            equiv(ii,jj,ier_equiv);
            if(ier_equiv = 0)then continue;
          {end;}
   {-----------------------------------------------------------------}

        end;
        ar23(ii,jj,ier_mat);
        if(ier_mat <> 0)then continue;
        mat_mult(r12,r23,r13);
        matinv(r13,r31);

        {Indexation des n-2 autres taches}
        ns1:=nsol+1;
        indexe(ns1,ier_indexe);
        if(ier_indexe = 1)then continue;

        {stockage}
        if (nsol > 28) then begin
          erreur('Nb of solutions > 30');
          exit;
        end;
        nsol:=nsol+1;
        calc_res(nsol);
        calc_residu_coord(nsol);
      end;
    end;

    if (nsol <= 0) then begin
      ier:=1;
      exit;
    end else begin
      ier:=0;
    end;

end;

procedure Lauindex;
{-----------------}
var
     ier,i,j,nn,ii                                   : integer;
     systeme_old,bravais_old                         : string;
     a_old,b_old,c_old,alpha_old,beta_old,gamma_old  : real;
     i1,i2,i3,j1,j2,j3,pgcd                          : integer;
     x                                               : real;

begin
  if (n1 < 0) or (n1 > nobs) or (n2 < 0) or (n2 > nobs) or (n1 = n2)then begin
    erreur('Invalid fundamental spot numbers');
    exit;
  end;
  nsol:=0;
  xyz;

{Angle entre les 2 vecteurs observs}
    ca1:=x3o[n1]*x3o[n2]+y3o[n1]*y3o[n2]+z3o[n1]*z3o[n2];
    a1:=arcos(ca1);
    sa1:=sin(a1);

{Gnration des vecteurs du rseau rciproque}
    gener(ier);
    if (ier = 1)then begin
     erreur('Erreur dans la procdure gener');
     exit;
    end;

{Recherche indexation}
    search(ier);

{Choix de la solution}
    no_sol:=0;
    nn:=1;
    r1_min:=10000000;
    if (nsol = 0) then begin
      erreur('No solution');
      message_matrice:='';
      exit;
    end else begin
      r1_min:=1.e09;
      for i:=1 to nsol do begin
        if (residu_hkl[i] < r1_min)then begin
          nn:=i;
          r1_min:=residu_hkl[i];
        end;
      end;
      no_sol:=nn;
      afine_mat;
    end;

    matinv(r13,r31);
  end;

end.
