unit lidata;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  Tflidata = class(TForm)
    Panel1: TPanel;
    Label6: TLabel;
    edit2: TEdit;
    edit3: TEdit;
    ListBox3: TListBox;
    case8: TEdit;
    case9: TEdit;
    ListBox2: TListBox;
    edit4: TEdit;
    edit5: TEdit;
    case11: TEdit;
    edit6: TEdit;
    edit7: TEdit;
    case12: TEdit;
    case13: TEdit;
    edit8: TEdit;
    edit14: TEdit;
    edit10: TEdit;
    edit11: TEdit;
    edit16: TEdit;
    edit17: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label3: TLabel;
    Edit23: TEdit;
    Label4: TLabel;
    Edit9: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit15: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    RadioGroup1: TRadioGroup;
    Edit28: TEdit;
    Edit29: TEdit;
    procedure lit_systeme(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure lit_case(Sender: TObject);
    procedure numero_entree(Sender: TObject);
    procedure abandon(Sender: TObject);
    procedure verif_groupe(Sender: TObject);
    procedure initialisation(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  flidata: Tflidata;

implementation

{$R *.DFM}
uses oemath;
var
  no_case             : integer;

procedure Tflidata.lit_systeme(Sender: TObject);{
----------------------------------------------}
begin

  edit2.color:=clwhite;
  edit3.color:=clwhite;
  edit4.color:=clwhite;
  edit5.color:=clwhite;
  edit6.color:=clwhite;
  edit7.color:=clwhite;
  edit2.readonly:=false;
  edit3.readonly:=false;
  edit4.readonly:=false;
  edit5.readonly:=false;
  edit6.readonly:=false;
  edit7.readonly:=false;
  case listbox3.ItemIndex of
    0 : begin
          systeme:='CUBI';
          edit3.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit4.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then begin
          edit3.text:=edit2.text;
          edit4.text:=edit2.text;
          end;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
        end;
    1 : begin
          systeme:='QUAD';
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then edit3.text:=edit2.text;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
        end;
    2 : begin
          systeme:='ORTH';
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
        end;
    3 : begin
          systeme:='HEXA';
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then edit3.text:=edit2.text;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='120';
        end;
    4 : begin
          systeme:='RHOM';
          edit3.color:=clsilver;
          edit3.readonly:=true;
          edit4.color:=clsilver;
          edit4.readonly:=true;
          edit6.color:=clsilver;
          edit6.readonly:=true;
          edit7.color:=clsilver;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then begin
            edit3.text:=edit2.text;
            edit4.text:=edit2.text;
          end;
          edit5.text:='';
          edit6.text:='';
          edit7.text:='';
        end;
    5 : begin
          systeme:='MONO';
          edit5.color:=clsilver;
          edit7.color:=clsilver;
          edit5.readonly:=true;
          edit7.readonly:=true;
          edit5.text:='90';
          edit7.text:='90';
          edit6.text:='';
        end;
    6 : begin
          systeme:='TRIC';
          edit2.text:='';
          edit3.text:='';
          edit4.text:='';
          edit5.text:='';
          edit6.text:='';
          edit7.text:='';
        end;
  end;
end;

procedure Tflidata.sortie(Sender: TObject);{
-----------------------------------------}
var
ier,i                     : integer;
s                         : string;
nomf                      : TextFile;
delta                     : real;

begin

 {Lecture du systme}
 i:=listbox3.itemIndex;
 if (i = -1)then begin
   erreur('Please choose a lattice type!');
   exit;
 end;
 systeme:=listbox3.items[i];
 systeme:=uppercase(copy(systeme,1,4));

 {Lecture du rseau}
 i:=listbox2.ItemIndex;
 if (i = -1)then begin
   erreur('Please choose a lattice type!');
   exit;
 end;
 bravais:=uppercase(listbox2.items[i]);
 bravais:=trimright(bravais);
 for i:=1 to 8 do begin
    if (bravais = bra[i]) then begin
      ibrav:=i;
      break;
    end;
 end;

 {Titre}
 titre:=edit23.text;

 {Lecture de la maille}
 val(edit2.text,a,ier);
 val(edit3.text,b,ier);
 val(edit4.text,c,ier);
 val(edit5.text,alpha,ier);
 val(edit6.text,beta,ier);
 val(edit7.text,gamma,ier);

 {groupe d'espace}
 verif_groupe(Sender);

 {Lecture donnes manip}
 val(edit8.text,distance,ier);
 val(edit9.text,angle,ier);

 val(edit10.text,lambda_min,ier);
 val(edit11.text,lambda_max,ier);
 val(edit18.text,hauteur,ier);
 val(edit13.text,largeur,ier);
 if (ier > 0)then begin
   erreur('read error');
   exit;
 end;

 {gomtrie}
 if(RadioGroup1.ItemIndex = 0)then geom:='FLAT';
 if(RadioGroup1.itemIndex = 1)then geom:='CYL';

 delta:=180-abs(angle);
 if(angle <> 0)then delta:=delta*abs(angle)/angle;
 codelta:=cos(delta/57.2957);
 sidelta:=sin(delta/57.2957);

 setmat;
 message_matrice:='';
 close;
end;

procedure Tflidata.lit_case(Sender: TObject);{
-------------------------------------------}
var
   ier                 : integer;
begin
  case no_case of

  1: begin
       val(edit2.text,a,ier);
       if(ier > 0)then begin
         Erreur('Error on a value!');
         edit2.setfocus;
         exit;
       end;
       if (systeme = 'CUBI') or (systeme = 'RHOM') then begin
         edit3.text:=edit2.text;
         edit4.text:=edit2.text;
       end;
       if (systeme = 'QUAD') or (systeme = 'TETRA') or (systeme = 'HEXA') then
       edit3.text:=edit2.text;
     end;

  2: begin
       val(edit3.text,b,ier);
       if(ier > 0)then begin
         Erreur('Error on b value!');
         edit3.setfocus;
         exit;
       end;
     end;
  3: begin
       val(edit4.text,c,ier);
       if(ier > 0)then begin
         Erreur('Error on c value!');
         edit4.setfocus;
         exit;
       end;
     end;
  4: begin
       val(edit5.text,alpha,ier);
       if(ier > 0)then begin
         Erreur('Error on alpha value!');
         edit5.setfocus;
         exit;
       end;
       if (systeme = 'RHOM')then begin
         edit6.text:=edit5.text;
         edit7.text:=edit5.text;
       end;
     end;
  5: begin
       val(edit6.text,b,ier);
       if(ier > 0)then begin
         Erreur('Error on beta value!');
         edit6.setfocus;
         exit;
       end;
     end;
  6: begin
       val(edit7.text,gamma,ier);
       if(ier > 0)then begin
         Erreur('Error on gamma value!');
         edit7.setfocus;
         exit;
       end;
     end;
  7: begin
       val(edit8.text,distance,ier);
       if(ier > 0)then begin
         Erreur('Error on distance value!');
         edit8.setfocus;
         exit;
       end;
     end;
  8: begin
      { val(edit9.text,angle,ier);
       if(ier > 0)then begin
         Erreur('Erreur d''criture sur l''angle!');
         edit9.setfocus;
         exit;
       end;}
     end;
  9: begin
       val(edit10.text,lambda_min,ier);
       if(ier > 0)then begin
         Erreur('Error on Lambda Min value!');
         edit10.setfocus;
         exit;
       end;
     end;
  10: begin
       val(edit11.text,lambda_max,ier);
       if(ier > 0)then begin
         Erreur('Error on Lambda Max value!');
         edit11.setfocus;
         exit;
       end;
     end;
  11: begin
       val(edit18.text,hauteur,ier);
       if(ier > 0)then begin
         Erreur('Erreur d''criture sur la hauteur!');
         edit12.setfocus;
         exit;
       end;
     end;
  12: begin
       val(edit13.text,largeur,ier);
       if(ier > 0)then begin
         Erreur('Erreur d''criture sur la largeur!');
         edit13.setfocus;
         exit;
       end;
     end;

  end;

end;
procedure Tflidata.numero_entree(Sender: TObject);{
------------------------------------------------}
begin
  if(edit2.focused) then no_case:=1;   {a}
  if(edit3.focused) then no_case:=2;   {b}
  if(edit4.focused) then no_case:=3;   {c}
  if(edit5.focused) then no_case:=4;   {alpha}
  if(edit6.focused) then no_case:=5;   {beta}
  if(edit7.focused) then no_case:=6;   {gamma}
  if(edit8.focused) then no_case:=7;   {distance}
  if(edit9.focused) then no_case:=8;   {angle}
  if(edit10.focused) then no_case:=9;  {lbd1}
  if(edit11.focused) then no_case:=10; {lbd2}
  if(edit18.focused) then no_case:=11; {hauteur}
  if(edit13.focused) then no_case:=12; {largeur}
end;

procedure Tflidata.abandon(Sender: TObject);{
------------------------------------------}
begin
  nom_fichier_donnees:='';
  close;
end;

procedure Tflidata.verif_groupe(Sender: TObject);{
-----------------------------------------------}
var
  Nomf                        : TextFile;
  s,groupe                    : string;

begin
   groupe_espace:=uppercase(edit20.text);
   groupe_espace:=trimright(groupe_espace);
   groupe_espace:=trimleft(groupe_espace);
   edit20.text:=groupe_espace;

   if(groupe_espace = '')then begin
      groupe_espace:='P-1';
      edit20.text:='P-1';
      edit20.font.color:=clred;
      exit;
   end;
   AssignFile(nomf,'orientexpress.grp');
   reset(nomf);
   groupe:=copy(groupe_espace,2,12);
   groupe:=trimleft(groupe);

   {Ce groupe exite-il dans le fichier OrientExpress.grp?}
   while (not eof(nomf)) do begin
     readln(nomf,s);
     s:=trimleft(s);
     if(s = '')then continue;
     if(s =  groupe)then begin
       edit20.font.color:=clblue;
       message_groupe:='';
       closeFile(nomf);
       exit;
     end;
   end;

   message_groupe:=
  'Unknown space group or no general extinction (except Bravais lattice)';
   closeFile(nomf);

end;

procedure Tflidata.initialisation(Sender: TObject);{
-------------------------------------------------}
var
  nomf                  : TextFile;
  s                     : string;
  i                     : integer;
label depassement;

begin
  top:=40;
  left:=2;
  flidata.caption:='Data Acquisition';

  if (nom_fichier_donnees = 'Not saved') then goto depassement;
  if (length(nom_fichier_donnees) > 0) then begin
    flidata.caption:='Data Modification';

    AssignFile(nomf,nom_fichier_donnees);
    reset(nomf);
    readln(nomf,titre);
    readln(nomf,systeme);        {Systeme}
    readln(nomf,bravais);
    readln(nomf,groupe_espace);
    readln(nomf,a,b,c,alpha,beta,gamma);
    readln(nomf,distance,angle);
    readln(nomf,lambda_min,lambda_max);
    readln(nomf,largeur,hauteur);
    readln(nomf,geom);
    closeFile(nomf);

  depassement:
    if(systeme = 'C')then systeme:='CUBI';
    if(systeme = 'Q')then systeme:='TETR';
    if(systeme = 'O')then systeme:='ORTH';
    if(systeme = 'H')then systeme:='HEXA';
    if(systeme = 'R')then systeme:='RHOM';
    if(systeme = 'M')then systeme:='MONO';
    if(systeme = 'T')then systeme:='TRIC';
    bravais:=trimright(bravais);
    for i:=1 to 8 do begin
      if (bravais = bra[i]) then begin
        ibrav:=i;
        break;
      end;
    end;
    setmat;
    lecgroup;
  end;

  listbox3.itemindex:=-1;
  with listbox3 do begin
      if (systeme = 'CUBI')then itemIndex:=0;
      if (systeme = 'QUAD')then itemIndex:=1;
      if (systeme = 'ORTH')then itemIndex:=2;
      if (systeme = 'HEXA')then itemIndex:=3;
      if (systeme = 'RHOM')then itemIndex:=4;
      if (systeme = 'MONO')then itemIndex:=5;
      if (systeme = 'TRIC')then itemIndex:=6;
  end;

  listbox2.ItemIndex:=-1;
  bravais:=copy(bravais,1,1);
  bravais:=trimright(bravais);
  bravais:=uppercase(bravais);
  with listbox2 do begin
      if (bravais = 'P') or (bravais = '') then listbox2.itemIndex:=0;
      if (bravais = 'F')then listbox2.itemIndex:=1;
      if (bravais = 'I')then listbox2.itemIndex:=2;
      if (bravais = 'A')then listbox2.itemIndex:=3;
      if (bravais = 'B')then listbox2.itemIndex:=4;
      if (bravais = 'C')then listbox2.itemIndex:=5;
      if (bravais = 'R')then listbox2.itemIndex:=6;
      if (bravais = 'D')then listbox2.itemIndex:=7;
  end;

  edit23.text:=titre;
  str(a:7:3,s);
  edit2.text:=s;
  str(b:7:3,s);
  edit3.text:=s;
  str(c:7:3,s);
  edit4.text:=s;
  str(alpha:7:2,s);
  edit5.text:=s;
  str(beta:7:2,s);
  edit6.text:=s;
  str(gamma:7:2,s);
  edit7.text:=s;

  edit20.text:=groupe_espace;

  if (distance = 0)then distance:=4;
  str(distance:6:2,s);
  edit8.text:=s;
  str(angle:6:0,s);
  edit9.text:=s;
  if (lambda_min = 0)then lambda_min:=0.35;
  if (lambda_max = 0)then lambda_max:=2.5;
  str(lambda_min:7:5,s);
  edit10.text:=s;
  str(lambda_max:7:5,s);
  edit11.text:=s;
  if (largeur = 0)then largeur:=17;
  if (hauteur = 0)then hauteur:=13;
  str(hauteur:5:2,s);
  edit18.text:=s;
  str(largeur:5:2,s);
  edit13.text:=s;

  Radiogroup1.ItemIndex:=-1;
  if (geom = '')then geom:='FLAT';
  if (geom = 'FLAT')then RadioGroup1.ItemIndex:=0;
  if (geom = 'CYL')then RadioGroup1.ItemIndex:=1;

  nom_fichier_donnees:='Not saved';
 end;

end.
