unit chaine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls;

type
  Tfchaine = class(TForm)
    Button1: TButton;
    Label4: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    Edit2: TEdit;
    Label1: TLabel;
    ListBox1: TListBox;
    Label6: TLabel;
    ListBox3: TListBox;
    Panel2: TPanel;
    Label3: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    Panel3: TPanel;
    Label2: TLabel;
    ListBox2: TListBox;
    procedure lit(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure chercher(Sender: TObject);
    procedure lit_un_fichier(Sender: TObject);
    procedure init(Sender: TObject);
    procedure cle_entree(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fchaine: Tfchaine;

implementation

{$R *.DFM}
var
  liste_fichier,fichiers_absents        : array[1..200] of string;
  iexiste                               : array[1..200] of boolean;
  nb_fichiers,nb_fichiers_absents       : integer;

procedure erreur(s:string);{
---------------------------}
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure Tfchaine.lit(Sender: TObject);{
----------------------------------------}
var
   n,i,i1,i2          : integer;
   s,s2            : string;
   nomf         : textfile;
begin
  s:=edit2.text+'.dpr';
  left:=0;
  top:=0;
  assignfile(nomf,s);
  reset(nomf);
  while  not eof(nomf) do begin
    readln(nomf,s);
    i2:=pos('.pas',s);
    if (i2 > 0)then begin
      i1:=pos('in ',s);
      s2:=copy(s,i1+4,i2-i1);
      if not fileExists(s2) then begin
        listBox3.items.add(s2);
        nb_fichiers_absents:=nb_fichiers_absents+1;
        fichiers_absents[nb_fichiers_absents]:=s2;
      end else begin
        ListBox1.items.add(s2);
        nb_fichiers:=nb_fichiers+1;
        liste_fichier[nb_fichiers]:=s2;
      end;
    end;
  end;
  closefile(nomf);
  if (nb_fichiers = 0)then begin
    erreur('Pas trouv de fichiers');
    exit;
  end else begin
    panel2.visible:=true;
  end;
end;

procedure Tfchaine.sortie(Sender: TObject);{
-------------------------------------------}
begin
  close;
end;

procedure Tfchaine.chercher(Sender: TObject);{
---------------------------------------------}
var
  s0,s,s1,chaine                 : string;
  i,n,n_trouve                    : integer;
  nomf                            : TextFile;
begin
  listbox2.clear;
  chaine:=edit1.text;
  chaine:=lowerCase(chaine);
  if (chaine = '') then exit;
  for i:=1 to nb_fichiers do begin
    assignFile(nomf,liste_fichier[i]);
    reset(nomf);
    n:=0;
    n_trouve:=0;
    while not eof(nomf) do begin
      readln(nomf,s0);
      s:=lowerCase(s0);
      n:=n+1;
      str(n:4,s1);
      if (pos(chaine,s) > 0)then begin
        n_trouve:=n_trouve+1;
        if (n_trouve = 1)then begin
          listbox2.items.add('  ');
          listbox2.items.add(liste_fichier[i]);
        end;
        listbox2.items.add(s1+s0);
      end;
    end;
    closeFile(nomf);
  end;
 end;

procedure Tfchaine.lit_un_fichier(Sender: TObject);{
---------------------------------------------------}
var
  s0,s,s1,chaine                  : string;
  i,n,n_trouve,no_fichier         : integer;
  nomf                            : TextFile;
begin
  listbox2.clear;
  chaine:=edit1.text;
  chaine:=lowerCase(chaine);
  if(chaine = '')then exit;
  no_fichier:=listbox1.itemIndex+1;
 { edit2.text:=inttostr(no_fichier);}
  assignFile(nomf,liste_fichier[no_fichier]);
  reset(nomf);
  n:=0;
  n_trouve:=0;
  while not eof(nomf) do begin
    readln(nomf,s0);
    s:=lowercase(s0);
    n:=n+1;
    str(n:4,s1);
    if (pos(chaine,s) > 0)then begin
      n_trouve:=n_trouve+1;
      if (n_trouve = 1)then begin
        listbox2.items.add('  ');
        listbox2.items.add(liste_fichier[no_fichier]);
      end;
      listbox2.items.add(s1+s0);
    end;
  end;
  closeFile(nomf);

end;

procedure Tfchaine.init(Sender: TObject);{
-----------------------------------------}
begin
  left:=0;
  top:=0;
  panel2.visible:=false;
end;

procedure Tfchaine.cle_entree(Sender: TObject; var Key: Char);{
--------------------------------------------------------------}
begin
  if (ord(key) = 13) then lit(sender);
end;

end.
