{Dessin  l'cran}
procedure Tfdessin.dessin(Sender: TObject);{
-------------------------------------------}
var
  s                                                   : string;
  xp,yp,x3,y3,z3,x3p,y3p,z3p,xx4,yy4,zz4,ah,ak,al,den : real;
  rhkl,r2hkl                                          : real;
  xf,yf,vv,axe_min,rsph2,rayon_carre,som              : real;
  x,y,h,l                                             : integer;
  i,j,xg,xd,yg,yd                                     : integer;
  ih,ik,il,hmax,kmax,lmax,iih,iik,iil,pgcd,kl,lh,hk   : integer;

begin
  {Ecriture titre}
  fdessin.caption:='OrientExpress. '+'  '+titre;
  image1.canvas.pen.color:=clblack;

  xg:=xo+round(xn*echel);
  yg:=yo+round(yn*echel);
  xd:=xo+round(xm*echel);
  yd:=yo+round(ym*echel);

  {Diagramme Laue}
  if(type_diagramme = 'laue') then begin
     if (length(nom_fichier_image) > 0) then begin
       image1.picture.assign(clipboard);    {Rcupration de l'image scaner}
     end else begin
       fdessin.image1.canvas.rectangle(xg,yg,xd,yd);  {Cadre}
     end;

     {Trou central}
     if(angle = 0) or (abs(angle) = 180) then
     image1.canvas.ellipse(xo-10,yo-10,xo+10,yo+10) ;

     {Croix}
     image1.canvas.moveto(xo-5,yo);
     image1.canvas.lineto(xo+5,yo);
     image1.canvas.moveto(xo,yo-5);
     image1.canvas.lineto(xo,yo+5);

     {Ecriture nom du fichier}
     s:=ExtractFileName(nom_fichier_donnees);
     fdessin.image1.canvas.font.color:=clred;
     fdessin.image1.canvas.textout(xg+5,yd-15,s);
     fdessin.image1.canvas.font.color:=clblack;

     {Dessin des taches observes}
     if(nobs > 0)
       and (message_matrice <> 'Matrix before reorientation')
       and (message_matrice <> 'Matrix after rotation')
       and (message_matrice <> 'Matrix defined by the user')
       and (message_matrice <> 'Orientation matrix after reorienting')
       and (message_matrice <>
 'Caution! The original matrix was modified. Use MATRIX+RESTORE to restore it.')
       and (flag_rotation = 0) then begin
       image1.canvas.pen.color:=clblue;
       for i:=1 to nobs do begin
          x:=xo+trunc(xobs[i]*echel);
          y:=yo-trunc(yobs[i]*echel);
          image1.canvas.ellipse(x-3,y-3,x+3,y+3);
       end;
       image1.canvas.pen.color:=clblack;
     end;

     {Dessin des taches calcules}
     if (nom_fichier_image <> '')then begin
       image1.canvas.brush.color:=clred;
       image1.canvas.pen.color:=clred;
     end;
     for i:=1 to nt do begin
        x3:=r31[1,1]*h3[i]+r31[1,2]*k3[i]+r31[1,3]*l3[i];
        if(x3 < 0.00001)then continue;
        wl:=x3/qhkl[i];
        if (wl < lambda_min) or (wl > lambda_max) then continue;
        y3:=r31[2,1]*h3[i]+r31[2,2]*k3[i]+r31[2,3]*l3[i];
        z3:=r31[3,1]*h3[i]+r31[3,2]*k3[i]+r31[3,3]*l3[i];
        x3p:=x3*wl-1;
        y3p:=y3*wl;
        z3p:=z3*wl;
        xx4:=x3p*codelta-y3p*sidelta;
        if (abs(xx4) < 0.0001) then continue;
        yy4:=x3p*sidelta+y3p*codelta;
        zz4:=z3p;
        if (geom = 'CYL') then begin
           xf:=distance*arctan2(-yy4,xx4);
           yf:=zz4*distance/sqrt(xx4*xx4+yy4*yy4);
         end else begin
           vv:=-distance/xx4;
           xf:=vv*yy4;
           yf:=-vv*zz4;
           if (xx4 <= 0) then continue
        end;
        if (yf >= Ym) or (yf <= yn) then continue;
        if (xf >= Xm) or (xf <= xn) then continue;

        x:=xo+trunc(xf*echel);
        y:=yo-trunc(yf*echel);
        kl:=abs(k3[i])+abs(l3[i]);
        lh:=abs(l3[i])+abs(h3[i]);
        hk:=abs(h3[i])+abs(k3[i]);
        image1.canvas.ellipse
        (x-rayon_ellipse,y-rayon_ellipse,x+rayon_ellipse,y+rayon_ellipse);
     end;
     image1.canvas.brush.color:=clwhite;
     image1.canvas.pen.color:=clblack;

     {Taches supplmentaires}
     if(ns <> 0)
       and (message_matrice <> 'Matrix after reorientation')
       and (message_matrice <> 'Matrix after rotation')
       and (message_matrice <> 'Matrix defined by the user')
       and (flag_rotation = 0)
       and (message_matrice <> 'Orientation matrix after reorienting')
       then begin
       image1.canvas.pen.color:=clred;
       for i:=1 to ns do begin
         x:=xo+trunc(x_sup[i]*echel);
         y:=yo-trunc(y_sup[i]*echel);
         image1.canvas.moveto(x-3,y-3);
         image1.canvas.lineto(x+3,y+3);
         image1.canvas.moveto(x-3,y+3);
         image1.canvas.lineto(x+3,y-3);
       end;
    end;

    {Screen.Cursor:=CrCross;}
    fdessin.print1.enabled:=true;
    fdessin.TracImprimante1.enabled:=true;
    fdessin.ImpressionListe1.enabled:=true;
    image1.refresh;
end;

 {Projection stro}
 if(type_diagramme = 'stereo') then begin

   l:=round(rstereo*echel);
   h:=round(rstereo*echel);

   {Cercle de la projection et effacement}
   image1.canvas.pen.color:=clred;
   image1.canvas.ellipse(xo-l,yo-l,xo+l,yo+l);
   image1.canvas.pen.color:=clblack;

   {Eciture nom du fichier}
   fdessin.image1.canvas.font.color:=clblack;
   s:=extractFileName(nom_fichier_donnees);
   fdessin.image1.canvas.textout(image1.left+5,image1.height-15,s);

   {croix}
   image1.canvas.moveto(xo-5,yo);
   image1.canvas.lineto(xo+5,yo);
   image1.canvas.moveto(xo,yo-5);
   image1.canvas.lineto(xo,yo+5);

   axe_min:=500;
   for i:=1 to 3 do if (axe_min > celr[i]) then axe_min:=celr[i];
   rayon_carre:=rstereo*rstereo;
   rsph2:=sqr(indmax_stereo*axe_min);
   hmax:=2+round(indmax_stereo*axe_min/celr[1]);
   kmax:=2+round(indmax_stereo*axe_min/celr[2]);
   lmax:=2+round(indmax_stereo*axe_min/celr[3]);
   for ih:=-hmax to hmax do begin
     for ik:=-kmax to kmax do begin
       for il:=-lmax to lmax do begin
         if(ih = 0) and (ik = 0) and (il = 0) then continue;
        { if (ih = 0) and (ik = 1) and (il = 0)then begin
           s:='';
         end; }
         if (systeme = 'HEXA') and (bravais = 'R') and (((-ih+ik+il) mod 3) <> 0)
         then continue;
         x3:=r31[1,1]*ih+r31[1,2]*ik+r31[1,3]*il;
         y3:=r31[2,1]*ih+r31[2,2]*ik+r31[2,3]*il;
         z3:=r31[3,1]*ih+r31[3,2]*ik+r31[3,3]*il;
         som:=x3*x3+y3*y3+z3*z3;
         if(som > rsph2) then continue;
         som:=sqrt(som);
         x3:=x3/som;
         y3:=y3/som;
         z3:=z3/som;
         x3:=x3+1;
         if (abs(x3) < 0.000001) or (x3 = -1) then continue;
         xp:=-rstereo*y3/x3;
         //xp:=rstereo*y3/x3;  (inversion x en -x pour G. Rolland)
         yp:=rstereo*z3/x3;
         som:=xp*xp+yp*yp;
         if(som > rayon_carre) then continue;
         x:=xo+trunc(xp*echel);
         y:=yo-trunc(yp*echel);
         if (ih = 0) and (ik = 0)then begin
           premier(ih,ik,il,iih,iik,iil,pgcd);
           image1.canvas.pen.color:=clblue;
           image1.canvas.ellipse(x-3,y-3,x+3,y+3);
           hkltostr(iih,iik,iil,s);
           image1.canvas.textout(x,y,s);
         end else if (ik = 0) and (il = 0)then begin
           premier(ih,ik,il,iih,iik,iil,pgcd);
           image1.canvas.pen.color:=clred;
           image1.canvas.ellipse(x-3,y-3,x+3,y+3) ;
           hkltostr(iih,iik,iil,s);
           image1.canvas.textout(x,y,s);
         end else if (il = 0) and (ih = 0)then begin
           premier(ih,ik,il,iih,iik,iil,pgcd);
           image1.canvas.pen.color:=clgreen;
           image1.canvas.ellipse(x-3,y-3,x+3,y+3) ;
           hkltostr(iih,iik,iil,s);
           image1.canvas.textout(x,y,s);
         end;
         image1.canvas.pen.color:=clblack;
         image1.canvas.ellipse(x-2,y-2,x+2,y+2) ;
     end;
     end;
   end;

   fdessin.print1.enabled:=true;
   fdessin.TracImprimante1.enabled:=true;
   fdessin.ImpressionListe1.enabled:=true;
   image1.refresh;
 end;

end;

