unit hexatorhom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,math, Buttons;

type
  Tfhexatorhomb = class(TForm)
    Memo1: TMemo;
    ed1: TEdit;
    ed2: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    ed3: TEdit;
    ed4: TEdit;
    Edit36: TEdit;
    ed5: TEdit;
    ed6: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    Edit49: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure initialise(Sender: TObject);
    procedure sauve_rhombo(Sender: TObject);
    procedure sort(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fhexatorhomb: Tfhexatorhomb;

implementation

{$R *.DFM}

uses
  oemath;

var
  x,ar,alfa  : real;

procedure Tfhexatorhomb.initialise(Sender: TObject);
//--------------------------------------------------
var
  s   : string;
begin
    str(a:7:3,s);
    ed1.text:=s;
    str(b:7:3,s);
    ed2.text:=s;
    str(c:7:3,s);
    ed3.text:=s;
    str(alpha:7:2,s);
    ed4.text:=s;
    str(beta:7:2,s);
    ed5.text:=s;
    str(gamma:7:2,s);
    ed6.text:=s;

//calcul de la maille rhomboedrique (ar, alfa)
    x:=sqrt(3+sqr(c/a));
    ar:=a*x/3;
    alfa:=2*57.29578*arcsin(3/(2*x));
    str(ar:7:3,s);
    edit1.text:=s;
    edit2.text:=s;
    edit3.text:=s;
    str(alfa:7:3,s);
    edit4.text:=s;
    edit5.text:=s;
    edit6.text:=s;
end;

procedure Tfhexatorhomb.sauve_rhombo(Sender: TObject);
//---------------------------------------------------
var
  s                     : string;
  nomf                  : textfile;
  w                     : word;
begin
  SaveDialog1.filterIndex:=1;
  if SaveDialog1.execute then begin
    s:=SaveDialog1.filename;
    if (pos('.dat',s)=0)then s:=s+'.dat';
    if FileExists(s) then begin
      beep;
      w:=messageDlg('This file already exists. Do you want to continue?',
      mtConfirmation,mbYesNoCancel,0);
      if (w = mrNo) or (w = mrAbort) then exit;
    end;
    assignfile(nomf,s);
    rewrite(nomf);
    writeln(nomf,titre);
    writeln(nomf,'RHOM');
    writeln(nomf,bravais);
    writeln(nomf,groupe_espace);
    writeln(nomf,ar:8:3,ar:8:3,ar:8:3,alfa:8:2,alfa:8:2,alfa:8:2);
    writeln(nomf,distance:8:2,angle:9:3);
    writeln(nomf,lambda_min:8:4,lambda_max:8:4);
    writeln(nomf,largeur:8:2,hauteur:8:2);
    writeln(nomf,geom);
    closefile(nomf);
    beep;
    a:=ar;
    b:=a;c:=a;
    alpha:=alfa;
    beta:=alfa;
    gamma:=alfa;
    systeme:='RHOM';
    showmessage('The input data file '+s+' has been saved. '+
    'The rhomboedral cell is now loaded');
    nom_fichier_donnees:=s;
    close;
  end;
end;

procedure Tfhexatorhomb.sort(Sender: TObject);
begin
   close;
end;

end.
