unit modifimage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  Tfmodifimage = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    RadioGroup2: TRadioGroup;
    Button1: TButton;
    procedure Abandon(Sender: TObject);
    procedure initialisation(Sender: TObject);
    procedure sortie_modif(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmodifimage: Tfmodifimage;

implementation

{$R *.DFM}
uses
  oemath, Calcul;

procedure Tfmodifimage.Abandon(Sender: TObject);{
------------------------------------------------}
begin
  close;
end;

procedure Tfmodifimage.initialisation(Sender: TObject);{
-------------------------------------------------------}
var
  s:  string;
begin
  radiogroup2.ItemIndex:=1;
  if (nom_fichier_image = '')then begin
    erreur ('No image loaded');
    close;
    exit;
  end;
  str(nb_pixel_cm:5:2,s);
  edit1.text:=s;
  edit2.text:=intToStr(x_origine);
  edit3.text:=intToStr(y_origine);
end;

procedure Tfmodifimage.sortie_modif(Sender: TObject);{
-----------------------------------------------------}
var
  x_origine_old,y_origine_old,ier,i        : integer;
  dx,dy,x,y                                : integer;
  nb_pixel_cm_old                          : real;
  s                                        : string;
  nomf                                     : TextFile;
begin
  x_origine_old:=x_origine;
  y_origine_old:=y_origine;
  nb_pixel_cm_old:=nb_pixel_cm;
  s:=edit1.text;
  val(s,nb_pixel_cm,ier);
  if (ier > 0)then begin
    erreur ('Error on scale reading!');
    exit;
  end;

  s:=edit2.text;
  val(s,x_origine,ier);
  if (ier > 0)then begin
    erreur('Error on X reading');
    exit;
  end;

  s:=edit3.text;
  val(s,y_origine,ier);
  if (ier > 0)then begin
    erreur('Error on Y reading');
    exit;
  end;

  {Modif ventuelle des coordonnes et indexation}
  (*if (radiogroup2.ItemIndex = 1)then begin
    close;
  end else begin *)
    dx:=x_origine-x_origine_old;
    dy:=y_origine-y_origine_old;
    for i:=1 to nobs do begin
      x:=x_origine+round(xobs[i]*nb_pixel_cm_old);
      y:=y_origine-round(yobs[i]*nb_pixel_cm_old);
      x:=x+dx;
      y:=y+dy;
      xobs[i]:=(x-x_origine)/nb_pixel_cm;
      yobs[i]:=-(y-y_origine)/nb_pixel_cm;
    end;
    (*AssignFile(nomf,'imageconst.txt');
    reset(nomf);
    readln(nomf,nb_pixel_cm);
    readln(nomf,x_origine,y_origine);
    closeFile(nomf);*)
    AssignFile(nomf,'imageconst.txt');
    rewrite(nomf);
    writeln(nomf,nb_pixel_cm);
    writeln(nomf,x_origine,y_origine);
    closeFile(nomf);
    showmessage('The new constants were saved in the ImageConst.txt file');
    close;
    fcalcul.visible:=true;
  //end;

end;

end.
