{OEINDEX: Indexation du diagramme exprimental, lit les paramtres et
indexe en faisant appel  la routine lauindx de indexe.dll cre par
FORTRAN}
unit Calcul;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, ExtCtrls, Buttons;

type
  Tfcalcul = class(TForm)
    CancelBtn: TBitBtn;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Panel2: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Panel3: TPanel;
    Label9: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Panel4: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Panel5: TPanel;
    Label14: TLabel;
    Edit14: TEdit;
    BitBtn2: TBitBtn;
    Label15: TLabel;
    Edit15: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure verif_champ(Sender: TObject);
    {procedure aide(Sender: TObject);}
    procedure click_calcul(Sender: TObject);
    procedure abandon_calcul(Sender: TObject);
    procedure formactivate(Sender: TObject);
    procedure decode_hkl1(Sender: TObject);
    procedure decode_hkl2(Sender: TObject);
    procedure aide_index(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

{procedure lifiche;
procedure solution_unique;}

var
 fcalcul                         : Tfcalcul;

implementation

uses dialogs, oemath, index, Mainmenu;

{$R *.DFM}

{Lecture}
procedure lifiche;{
------------------}
 var
   s       : string;
   ier     : integer;
begin
 {rcupration des indices}

 with fcalcul do begin

 {lecture de la tolrance}
   s:=edit14.text;
   val(s,eps,ier);
   if(ier <> 0)then begin
     erreur('Read error');
     edit14.setfocus;
     exit;
   end;
   eps:=eps/57.2957;

 {lecture de limite d'indice}
   s:=edit15.text;
   val(s,limite,ier);
   if(ier <> 0)then begin
     erreur('Read error');
     edit15.setfocus;
     exit;
   end;

   s:=edit1.text;
   val(s,n1,ier);
   if(ier <> 0)then edit1.setfocus;
   if( n1 < 1) or (n1 > nobs )then edit1.setfocus;

   s:=edit2.text;
   val(s,n2,ier);
   if(ier <> 0)then edit2.setfocus;
   if( n2 < 1) or (n2 > nobs )then edit2.setfocus;

{Lecture des bornes}
     s:=edit3.text;
     val(s,ih1,ier);
     if(ier <> 0)then edit3.setfocus;
     s:=edit4.text;
     val(s,ih2,ier);
     if(ier <> 0)then edit4.setfocus;
     s:=edit5.text;
     val(s,ik1,ier);
     if(ier <> 0)then edit5.setfocus;
     s:=edit6.text;
     val(s,ik2,ier);
     if(ier <> 0)then edit6.setfocus;
     s:=edit7.text;
     val(s,il1,ier);
     if(ier <> 0)then edit7.setfocus;
     s:=edit8.text;
     val(s,il2,ier);
     if(ier <> 0)then edit8.setfocus;
     jh1:=ih1;
     jh2:=ih2;
     jk1:=ik1;
     jk2:=ik2;
     jl1:=il1;
     jl2:=il2;

   s:=edit9.text;
   val(s,uvw[1],ier);
   if(ier <> 0)then edit9.setfocus;
   s:=edit10.text;
   val(s,uvw[2],ier);
   if(ier <> 0)then edit10.setfocus;
   s:=edit11.text;
   val(s,uvw[3],ier);
   if(ier <> 0)then edit11.setfocus;
 end;
end;

{Vrification des champs}
procedure Tfcalcul.verif_champ(Sender: TObject);{
------------------------------------------------}
begin;
  lifiche;
end;

{initialisation  la cration}
procedure Tfcalcul.FormCreate(Sender: TObject);{
-----------------------------------------------}
begin
  edit1.text:='1';
  edit2.text:='2';
  edit3.text:='-2';
  edit4.text:=' 2';
  edit5.text:='-2';
  edit6.text:=' 2';
  edit7.text:='-2';
  edit8.text:=' 2';
  edit12.text:='0  0  0';
  edit13.text:='0  0  0';
  edit14.text:='1.5';
  edit15.text:=IntToStr(limite);
end;

{Lancement du calcul des solutions}
procedure Tfcalcul.click_calcul(Sender: TObject);{
-------------------------------------------------}
var
  s              : string;
  i1,i2,i3,pgcd  : integer;
begin
 lifiche;
 set_pos_equiv;
 if(n1 = n2)then begin
     erreur('The spot numbers cannot be equal!');
     exit;
 end;
 decode_hkl1(sender);
 if (abs(h1_known)+abs(k1_known)+abs(l1_known) > 0)then begin
    ih1:=h1_known;
    ik1:=k1_known;
    il1:=l1_known;
  (*  if (systeme = 'HEXA') and (bravais = 'R') then begin
       i1:=2*ih1+ik1+il1;
       i2:=-ih1+ik1+il1;
       i3:=-ih1-2*ik1+il1;
       premier(i1,i2,i3,ih1,ik1,il1,pgcd);
       {h1:=i1;
       ik1:=i2;
       il1:=i3;}
     end; *)
     ih2:=ih1;
     ik2:=ik1;
     il2:=il1;
 end;
 decode_hkl2(sender);
 if (abs(h2_known)+abs(k2_known)+abs(l2_known) > 0)then begin
     jh1:=h2_known;
     jk1:=k2_known;
     jl1:=l2_known;
    (*if (systeme = 'HEXA') and (bravais = 'R') then begin
       i1:=2*jh1+jk1+jl1;
       i2:=-jh1+jk1+jl1;
       i3:=-jh1-2*jk1+jl1;
       premier(i1,i2,i3,jh1,jk1,jl1,pgcd);
       {h1:=i1;
       jk1:=i2;
       jl1:=i3; }
     end; *)
     jh2:=jh1;
     jk2:=jk1;
     jl2:=jl1;
 end;

 screen.cursor:=crhourglass;
 lauindex;
 screen.cursor:=crdefault;
 if (no_sol > 0)then begin
    str(no_sol:2,s);
    message_matrice:='The solution Nb.'+s+' is loaded';
    ident(r13,r13_old);
    fcalcul.visible:=false;
    foemenu.affinement1.enabled:=true;
 end;

end;

procedure Tfcalcul.abandon_calcul(Sender: TObject);{
---------------------------------------------------}
begin
  nsol:=0;
  ns:=0;
  message_matrice:='';
  close;
end;

procedure Tfcalcul.formactivate(Sender: TObject);{
-------------------------------------------------}
begin
  h1_known:=0;
  k1_known:=0;
  l1_known:=0;
  h2_known:=0;
  k2_known:=0;
  l2_known:=0;
  bitbtn1.setfocus;
end;

procedure Tfcalcul.decode_hkl1(Sender: TObject);{
------------------------------------------------}
var
  s,s1,s2,s3           : string;
  i,ier                : integer;
begin
  s:=edit12.text;
  s:=trimleft(s);
  if (s = '')then exit;

  {h}
  i:= pos(' ',s);
  if (i = 0)then begin
    erreur('Erreur de frappe!');
    exit;
  end else begin
    s1:=copy(s,1,i);
    delete(s,1,i);
  end;
  {k}
  s:=trimleft(s);
  i:= pos(' ',s);
  if (i = 0)then begin
    erreur('Erreur de frappe!');
    exit;
  end else begin
    s2:=copy(s,1,i);
    delete(s,1,i);
  end;
  {l}
  s3:=trimleft(s);
  if (s3 = '')then s3:='0';

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s3);
  val(s1,h1_known,ier);
  val(s2,k1_known,ier);
  val(s3,l1_known,ier);
end;

procedure Tfcalcul.decode_hkl2(Sender: TObject);{
------------------------------------------------}
var
  s,s1,s2,s3           : string;
  i,ier                : integer;
begin
  s:=edit13.text;
  s:=trimleft(s);
  if (s = '')then exit;

  {h}
  i:= pos(' ',s);
  if (i = 0)then begin
    erreur('Erreur de lecture!');
    exit;
  end else begin
    s1:=copy(s,1,i);
    delete(s,1,i);
  end;
  {k}
  s:=trimleft(s);
  i:= pos(' ',s);
  if (i = 0)then begin
    erreur('Erreur de lecture!');
    exit;
  end else begin
    s2:=copy(s,1,i);
    delete(s,1,i);
  end;
  {l}
  s3:=trimleft(s);
  if (s3 = '')then s3:='0';

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s3);
  val(s1,h2_known,ier);
  val(s2,k2_known,ier);
  val(s3,l2_known,ier);
  end;

procedure Tfcalcul.aide_index(Sender: TObject);
//---------------------------------------------
begin
   Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(12);
end;

end.
