{Acquisition de la matrice d'orientation}
unit Limat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, oemath, Buttons;

type
  Tflimat = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label3: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    edit0: TEdit;
    button1: TBitBtn;
    button2: TBitBtn;
    BitBtn1: TBitBtn;
    Panel11: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    RadioGroup4: TRadioGroup;
    procedure Abandon(Sender: TObject);
    procedure validation(Sender: TObject);
    procedure Aide_matrice(Sender: TObject);
    procedure verifie(Sender: TObject);
    procedure init_first(Sender: TObject);
    procedure ferme(Sender: TObject);
    procedure toto(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

procedure initialise_zero;
Procedure calcmat         (var rpqr :matrice3; var ier:integer);
Procedure matrois         (var i1,i2,ier : integer);

var
  flimat: Tflimat;
  reseaux,reseauy,reseauz,ier  :integer;
  px,qx,rx,py,qy,ry,pz,qz,rz   :real;
{  nomfich                      :textFile;}

implementation


{$R *.DFM}

procedure hklHtoR(var xh,yh,zh: real);
//------------------------------------
//entres: coordonnes h,k,l hexagonales (pas forcment entires).
//Sorties: coordonnes rhombo.
var
  x,y,z           : real;
begin
  x:=(2*xh+yh+zh)/3;
  y:=(-xh+yh+zh)/3;
  z:=(-xh-2*yh+zh)/3;
  xh:=x;
  yh:=y;
  zh:=z;
end;

Procedure xyzHtoR(var xx,yy,zz : real);
//------------------------------------
//entres: coordonnes x,y,z hexagonales. Sorties: coordonnes rhombo.
var
  x,y,z        : real;
begin
  x:=xx+zz;
  y:=-xx+yy+zz;
  z:=-yy+zz;
  xx:=x;
  yy:=y;
  zz:=z;
end;

procedure Tflimat.Abandon(Sender: TObject);
//------------------------------------------
begin
  message_matrice:='';
  flimat.visible:=false;
end;

procedure prod_vect(var x1,y1,z1,x2,y2,z2,x3,y3,z3 : real);
//---------------------------------------------------------
begin
  norm(x1,y1,z1);
  norm(x2,y2,z2);
  x3:=y1*z2-z1*y2;
  y3:=z1*x2-x1*z2;
  z3:=x1*y2-y1*x2;
  norm(x3,y3,z3);
end;

procedure conditionne_matrice;
//----------------------------
var
  x1,y1,z1,x2,y2,z2,x3,y3,z3      :real;
  {nomf                           :Textfile;
  som                             : real;
  i,j                             : integer;}
begin
  {assignfile(nomf,'verif.txt');
  rewrite(nomf);
  wr(nomf,'avant correction',r13);}
  x1:=r13[1,1];
  y1:=r13[2,1];
  z1:=r13[3,1];
  x2:=r13[1,2];
  y2:=r13[2,2];
  z2:=r13[3,2];
  trfo2(x1,y1,z1,r21);
  trfo2(x2,y2,z2,r21);
  prod_vect(x1,y1,z1,x2,y2,z2,x3,y3,z3);
  prod_vect(x3,y3,z3,x1,y1,z1,x2,y2,z2);
  trfo2(x1,y1,z1,r12);
  trfo2(x2,y2,z2,r12);
  trfo2(x3,y3,z3,r12);
  r13[1,1]:=x1;
  r13[2,1]:=y1;
  r13[3,1]:=z1;
  r13[1,2]:=x2;
  r13[2,2]:=y2;
  r13[3,2]:=z2;
  r13[1,3]:=x3;
  r13[2,3]:=y3;
  r13[3,3]:=z3;
  matinv(r13,r31);
  mat_mult(r31,r12,r32);
  matinv(r32,r23);
 { wr(nomf,'aprs correction',r13);
  writeln(nomf,'Paramtres aprs correction');
  for i:=1 to 3 do begin
    som:=0;
    for j:=1 to 3 do som:=som+r13[i,j]*r13[i,j];
    som:=sqrt(som);
    writeln(nomf,som:8:4);
  end;
  closefile(nomf);}

  end;

procedure Tflimat.validation(Sender: TObject);
//--------------------------------------------
var
  rpqr                         :matrice3;
  som,x,y,z                    :real;
  i                            :integer;

begin
  verifie(sender);
  {Axe OX}
  som:=abs(px)+abs(qx)+abs(rx);
  if(som <> 0)then begin
    if(reseaux = 0)then begin
      normd(px,qx,rx);
      r31[1,1]:=px;
      r31[1,2]:=qx;
      r31[1,3]:=rx;
      trfo(px,qx,rx,x,y,z,r10);
      r13[1,1]:=x;
      r13[2,1]:=y;
      r13[3,1]:=z;
    end;
    if(reseaux = 1)then begin
      normr(px,qx,rx);
      r13[1,1]:=px;
      r13[2,1]:=qx;
      r13[3,1]:=rx;
      trfo(px,qx,rx,x,y,z,r01);
      r31[1,1]:=x;
      r31[1,2]:=y;
      r31[1,3]:=z;
    end;
  end;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[1,i]:=0;
      r31[1,i]:=0;
    end;
  end;

  {Axe OY}
  som:=abs(py)+abs(qy)+abs(ry);
  if(som <> 0)then begin
    if(reseauy = 0)then begin
      normd(py,qy,ry);
      r31[2,1]:=py;
      r31[2,2]:=qy;
      r31[2,3]:=ry;
      trfo(py,qy,ry,r13[1,2],r13[2,2],r13[3,2],r10);
    end;
    if(reseauy = 1)then begin
      normr(py,qy,ry);
      r13[1,2]:=py;
      r13[2,2]:=qy;
      r13[3,2]:=ry;
      trfo(py,qy,ry,r31[2,1],r31[2,2],r31[2,3],r01);
    end;
  end ;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[2,i]:=0;
      r31[2,i]:=0;
    end;
  end;
  {Axe OZ}
  som:=abs(pz)+abs(qz)+abs(rz);
  if(som <> 0)then begin
    if(reseauz = 0)then begin
      normd(pz,qz,rz);
      r31[3,1]:=pz;
      r31[3,2]:=qz;
      r31[3,3]:=rz;
      trfo(pz,qz,rz,r13[1,3],r13[2,3],r13[3,3],r10);
    end;
    if(reseauz = 1)then begin
      normr(pz,qz,rz);
      r13[1,3]:=pz;
      r13[2,3]:=qz;
      r13[3,3]:=rz;
      trfo(pz,qz,rz,r31[3,1],r31[3,2],r31[3,3],r01);
    end;
  end;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[3,i]:=0;
      r31[3,i]:=0;
    end;
  end;

  rpqr[1,1]:=px;
  rpqr[1,2]:=qx;
  rpqr[1,3]:=rx;

  rpqr[2,1]:=py;
  rpqr[2,2]:=qy;
  rpqr[2,3]:=ry;

  rpqr[3,1]:=pz;
  rpqr[3,2]:=qz;
  rpqr[3,3]:=rz;

  calcmat (rpqr,ier);
  if (ier = 1) then exit;

 {code_data_dll};
  message_matrice:='Matrix defined by the user';
  nsol:=0;
  no_sol:=0;
  conditionne_matrice;
  ident(r13,r13_old);
  close;
end;

procedure initialise_zero;
//-------------------------
begin
  flimat.radiogroup1.itemIndex:=0;
  flimat.radiogroup2.itemIndex:=1;
  flimat.radiogroup3.itemIndex:=1;
  flimat.edit0.text:='0';
  flimat.edit1.text:='0';
  flimat.edit2.text:='0';
  flimat.edit3.text:='0';
  flimat.edit4.text:='0';
  flimat.edit5.text:='0';
  flimat.edit6.text:='0';
  flimat.edit7.text:='0';
  flimat.edit8.text:='0';
end;

procedure Tflimat.Aide_matrice(Sender: TObject);
//---------------------------------------------
begin
   Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(5);
end;

procedure Tflimat.verifie(Sender: TObject);
//-----------------------------------------
var
 chaine: string;

begin
//x ----------------------------------------------------------------------------
  chaine:=edit0.text;
  if(length(chaine) <> 0)then begin
  add_zero(chaine);
    val(chaine,px,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit0.text:='';
    end;
  end
  else px:=0;

  chaine:=edit1.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit1.text:='';
    end;
  end
  else qx:=0;

  chaine:=edit2.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit2.text:='';
    end;
  end
  else rx:=0;

//16/12/2002: Systme rhombodrique, Affichage en hexa
  if panel11.visible and (radiogroup4.itemindex = 0) then begin
    if (radiogroup1.itemindex = 0)then xyzHtoR(px,qx,rx);
    if (radiogroup1.itemindex = 1)then hklHtoR(px,qx,rx);
  end;

//y-----------------------------------------------------------------------------
  chaine:=edit3.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,py,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit3.text:='';
    end;
  end
  else py:=0;

  chaine:=edit4.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qy,ier);
    if(ier <> 0)then begin
      erreur ('Type error'); edit4.text:='';
    end;
  end
  else qy:=0;

  chaine:=edit5.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,ry,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit5.text:='';
    end;
  end
  else ry:=0;

//16/12/2002: Systme rhombodrique, Affichage en hexa
  if panel11.visible and (radiogroup4.itemindex = 0) then begin
    if (radiogroup2.itemindex = 0)then xyzHtoR(py,qy,ry);
    if (radiogroup2.itemindex = 1)then hklHtoR(py,qy,ry);
  end;

//Z-----------------------------------------------------------------------------
  chaine:=edit6.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,pz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit6.text:='';
    end;
  end
  else pz:=0;

  chaine:=edit7.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit7.text:='';
    end;
  end
  else qz:=0;

  chaine:=edit8.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit8.text:='';
    end;
  end
  else rz:=0;

//16/12/2002: Systme rhombodrique, Affichage en hexa
  if panel11.visible and (radiogroup4.itemindex = 0) then begin
    if (radiogroup3.itemindex = 0)then xyzHtoR(pz,qz,rz);
    if (radiogroup3.itemindex = 1)then hklHtoR(pz,qz,rz);
  end;

  reseaux:=radiogroup1.ItemIndex;
  reseauy:=radiogroup2.ItemIndex;
  reseauz:=radiogroup3.ItemIndex;

end;

{calcul de la matrice d'orientation}
Procedure calcmat(var rpqr :matrice3; var ier:integer);
//------------------------------------------------------
var
  izero                   : array[1..3] of integer;
  nzero,i,j,i1,i2         : integer;
  som,p,q,r,dt            : real;

begin
  ier:=0;
  nzero:=0;
  for i:=1 to 3 do begin
    som:=0.;
    izero[i]:=0;
    for j:=1 to 3 do som:=som+rpqr[i,j]*rpqr[i,j];
    if(som > 0.0001)then begin
      izero[i]:=1;
      nzero:=nzero+1;
    end;
  end;

  if(nzero = 1) then begin
    for i:=1 to 3 do begin
      if(izero[i] <> 0)then begin
        p:=r31[i,1];
        q:=r31[i,2];
        r:=r31[i,3];
        rot(p,q,r,i);
        mat_mult(r31,r12,r32);
        matinv(r32,r23);
        dt:=det(r23);
{        writeln(nomfich,'dterminant de R23 : ',dt:5:2);}
        dt:=abs(dt);
        if(dt < 0 ) or (abs(dt-1) > 0.001) then begin
          ier:=1;
          erreur(' Math error (determinant)');
        end;
        exit;
      end;
    end;
  end;

  if(nzero = 2)then begin
    for i:=1 to 3 do begin
      if(izero[i] = 1)then begin
        i1:=i;
        break;
      end;
    end;
    for i:=i1+1 to 3 do begin
      if(izero[i] = 1)then begin
        i2:=i;
        break;
      end;
    end;

    {writeln(nomfich,'i1: ',i1:2,'  i2: ',i2:2);
    writeln(nomfich,'Entre dans matrois');}

    ier:=0;
    matrois(i1,i2,ier);

    {writeln(nomfich,'Sortie de matrois');}

    if(ier = 1)then begin
      erreur('Error! The vectors are not perpendicular');
      with flimat do begin
        edit3.text:='0';
        edit4.text:='0';
        edit5.text:='0';
        edit6.text:='0';
        edit7.text:='0';
        edit8.text:='0';
      end;
      ier:=1;
      exit;
    end;
    mat_mult(r31,r12,r32);
    matinv(r32,r23);

    {wr(nomfich,'R31',r31);
    wr(nomfich,'R13',r13);
    wr(nomfich,'r32',r32);
    wr(nomfich,'r23',r23); }

    dt:=det(r23);
{    writeln(nomfich,'dterminant de R23 : ',dt:5:2);}
    dt:=abs(dt);
    {writeln(nomfich,'jer:=',jer:2,' Dterminant : ',dt:5:2);}
    if(dt < 0) or (abs(dt-1) > 0.001) then begin
      erreur('Error! The vectors are not perpendicular');
      with flimat do begin
        edit3.text:='0';
        edit4.text:='0';
        edit5.text:='0';
        edit6.text:='0';
        edit7.text:='0';
        edit8.text:='0';
      end;
      ier:=1;
      //erreur('The matrix determinant is different from 1');
    end;
    exit;
  end;

  if(nzero = 3)then begin
    mat_mult(r31,r12,r32);
    matinv(r32,r23);
    dt:=abs(det(r23));
    if(dt < 0) or (abs(dt-1) > 0.001)then begin
      ier:=1;
      erreur(' The matrix determinant is different from 1');
    end;
    exit;
  end;
end;

{     calcul de la matrice connaissant deux vecteurs i1 et i2. on fait
c     le produit vectoriel pour obtenir le 3me (attention au sens!)}

Procedure matrois  (var i1,i2,ier : integer);
//------------------------------------------
var
  s1,s2                     : string;
  x,y,z                     : vecteur3;
  i,j                       : integer;
  som,xx                    : real;

begin

{  wr(nomfich,'r20',r20);
  wr(nomfich,'r31',r31);
  wr(nomfich,'r20',r20);
  writeln(nomfich,'i1:',i1:2,' i2:',i2:2);}

  ier:=0;
  x[1]:=r31[i1,1];
  x[2]:=r31[i1,2];
  x[3]:=r31[i1,3];
  {writeln(nomfich,'X avant trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  trfo3(x,r20);
{  writeln(nomfich,'X aprs trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);  }
  norm(x[1],x[2],x[3]);
{  writeln(nomfich,'X aprs norm :',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  y[1]:=r31[i2,1];
  y[2]:=r31[i2,2];
  y[3]:=r31[i2,3];
 { writeln(nomfich,'Y avant trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);}
  trfo3(y,r20);
{  writeln(nomfich,'Y aprs trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);  }
  norm(y[1],y[2],y[3]);
{  writeln(nomfich,'Y aprs norm :',y[1]:10:5,y[2]:10:5,y[3]:10:5);}

{les deux vecteurs doivent tre perpendiculaires}
  som:=0;
  for  i:=1 to 3 do  som:=som+x[i]*y[i];
{  writeln(nomfich,'Produit scalaire : ',som:5:2);}
  if(som > 0.01)then begin
    str(i1:2,s1);
    str(i2:2,s2);
    {chaine:='les 2 vecteurs ne sont pas perpendiculaires';
    erreur(chaine);}
    //erreur('Error! the vectors are not perpendicular');
    ier:=1;
    exit;
  end;

  prodvec(x,y,z);
{  writeln(nomfich,'Vecteur Z avant trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}

{Changement de signe du produit vectoriel si i1+i2 est pair}
  {k:=i1+i2+1;
  xx:=(-1.)^k;}
  xx:=1;
  if((i1+i2) mod 2 =0) then xx:=-1;
  if((i1+i2) mod 2 <> 0)then xx:=1;
  for i:=1 to 3 do z[i]:=xx*z[i];

  trfo3(z,r02);
{  writeln(nomfich,'Vecteur Z aprs trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}

  for i:=1 to 3 do begin
    if(i = i1) or (i = i2) then continue;
    for j:=1 to 3 do r31[i,j]:=z[j];
  end;

  {  writeln(nomfich,'Matrice avant inversion :');}
  {  wr(nomfich,'R31',r31);}
  {  closefile(nomfich);   }

  matinv(r31,r13);
{      wr(nomfich,'r01',r01);
      wr(nomfich,'r10',r10);
      wr(nomfich,'r20',r20);
      wr(nomfich,'r02',r02);
      wr(nomfich,'r12',r12);
      wr(nomfich,'r21',r21);
      wr(nomfich,'r13',r13);
      wr(nomfich,'r31',r31);
      mat_mult(r13,r31,aux);
      wr(nomfich,'r13Xr31',aux);}

end;

procedure Tflimat.init_first(Sender: TObject);
//--------------------------------------------
begin
 { flimat.top:=(screen.height div 2)-240;
  flimat.left:=(screen.width div 2)-320;}
  if (systeme = 'RHOM') and (copy(groupe_espace,1,1)= 'R')then begin
     panel11.visible:=true;
     radiogroup4.itemindex:=1;
  end else panel11.visible:=false;
  initialise_zero;
  edit0.setfocus;
  left:=10;
  top:=40;
  {assignFile(nomfich,'espion.txt');
  rewrite(nomfich);}
end;

procedure Tflimat.ferme(Sender: TObject);
//---------------------------------------
begin
 { closefile(nomfich);}
end;

procedure Tflimat.toto(Sender: TObject);
//--------------------------------------
begin
 { flimat.top:=(screen.height div 2)-240;
  flimat.left:=(screen.width div 2)-320;}
end;


end.

