unit limage1;
{Pointage des taches sur l'image d'un diagramme de Laue, obtenue par scanner}
{Le fichier est un fichier bitmap}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, clipbrd, Menus, oemath,
  mainellipse, ExtDlgs, jpeg, ComCtrls, Buttons;

type
  Tflimage1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    scale1: TMenuItem;
    Measurecoord1: TMenuItem;
    Savecoord1: TMenuItem;
    cancel: TMenuItem;
    Origin1: TMenuItem;
    Measure1: TMenuItem;
    Enter1: TMenuItem;
    Panel2: TPanel;
    Label4: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Button3: TButton;
    Panel3: TPanel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button4: TButton;
    Help1: TMenuItem;
    Image2: TImage;
    return: TMenuItem;
    SaveDialog1: TSaveDialog;
    ListBox1: TListBox;
    Point1: TMenuItem;
    Cercle1: TMenuItem;
    Panel4: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    FitEllipse1: TMenuItem;
    Enter2: TMenuItem;
    Panel6: TPanel;
    Label5: TLabel;
    Edit3: TEdit;
    Button7: TButton;
    Button8: TButton;
    Label6: TLabel;
    Edit4: TEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel5: TPanel;
    TrackBar1: TTrackBar;
    Label7: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label8: TLabel;
    Resetcoord1: TMenuItem;
    procedure initialise(Sender: TObject);
    procedure lecture_nom_fichier(Sender: TObject);
    procedure pointe(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mesure_coordonnees(Sender: TObject);
    procedure sauve_coord(Sender: TObject);
    procedure mesure_echelle_regle(Sender: TObject);
    procedure lecture_distance(Sender: TObject);
    procedure entree_echelle_clavier(Sender: TObject);
    procedure oklecture_echelle(Sender: TObject);
    procedure creation_fiche(Sender: TObject);
    procedure Mode_Origine_point(Sender: TObject);
    procedure mode_Origine_cercle(Sender: TObject);
    procedure deplace_souris(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Aide_bitmap(Sender: TObject);
    procedure cancel_panel2(Sender: TObject);
    procedure abandon(Sender: TObject);
    procedure quitter(Sender: TObject);
    procedure rayon_croit(Sender: TObject);
    procedure rayon_decroit(Sender: TObject);
    procedure fit_ellipse(Sender: TObject);
    procedure entree_origine(Sender: TObject);
    procedure lecture_origine(Sender: TObject);
    procedure move_rayon(Sender: TObject);
    procedure cancel_cercle(Sender: TObject);
    procedure OK_origine_cercle(Sender: TObject);
    procedure onmouse_up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Resetcoord1Click(Sender: TObject);
{    procedure Fit_ellipse(Sender: TObject);}
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  flimage1: Tflimage1;

//const crMyCursor = 5;

implementation

uses Dessin;

{uses
  mainellipse;}
  

{Origine gomtrie rflexion}
  var

  xp_origine,yp_origine                                : array[1..4]of integer;
  n_origine,x_down,y_down                              : integer;
  coordx,coordy                                        : array[1..100] of real;
  rayon,delta,x_zoom,y_zoom,x_dernier,y_dernier        : integer;

  flag_mesure,flag_scale,flag_point,flag_cercle,
  flag_origine,mouse_down                              : boolean;

  nb_point_scale                                    : integer;
  x_scale,y_scale                                   : array [1..2] of integer;
  px_obs,py_obs                                     : array[1..30]of integer;
  xw,yw,flag,x_tache,y_tache                        : integer;

  tampon                                            : array[1..54] of char;
  //ligne                                             : array[0..800] of integer;
  //colonne                                           : array[0..600] of integer;
  ligne                                             : array[1..41] of integer;
  colonne                                           : array[1..41] of integer;
  x_souris,y_souris                                 : integer;
//  bmp : tbitmap;

{$R *.DFM}


procedure petit_cercle(var x,y,r : integer);
//-----------------------------------------
var
   arg,pas               : real;
   ix,iy,i               : integer;
begin
     pas:=360/(57.2957*50);
     //r:=4;
     with flimage1.image1.canvas do begin
       pen.color:=clred;
       moveto(x+r,y);
       for i:=1 to 51 do begin
         arg:=(i-1)*pas;
         ix:=round(x+r*cos(arg));
         iy:=round(y+r*sin(arg));
         if (i = 1) then moveto(ix,iy) else lineto(ix,iy);
       end;
       pen.color:=clblack;
     end;
end;

procedure croix(x,y : integer);{
-------------------------------}
var
  i  : integer;
begin
 (* with flimage1.image1.canvas do begin
    pen.color:=clred;
    moveto(x-4,y-4);
    lineto(x+4,y+4);
    moveto(x+4,y-4);
    lineto(x-4,y+4);
    moveto(x-4,y);
    lineto(x+4,y);
    moveto(x,y-4);
    lineto(x,y+4);
    pen.color:=clblack; *)
    i:=4;
    petit_cercle(x,y,i);
 // end;
end;

procedure ecrit_transparent(var x,y: integer; var s:string);
//----------------------------------------------------------
var
  tmpF                 : HFONT;
  tmpL                 : TlogFont;
  //oldFont              : HFONT;
  tmpTFont             : TFont;
  //offsetX              : Integer;
begin
  tmpTFont:=TFont.Create;
  tmpTFont.Assign(flimage1.image1.canvas.font);
  GetObject(flimage1.image1.canvas.Font.Handle,SizeOf(TLogFont),@tmpL);
  //tmpL.lfEscapement:=900;
  //tmpL.lfOrientation:=900;
  tmpF:=CreateFontIndirect(tmpL);
  flimage1.image1.canvas.Font.Handle:=tmpF;
  setBkMode(flimage1.image1.canvas.Handle,TRANSPARENT );
  flimage1.image1.canvas.Textout(x,y,s);
  setBkMode(flimage1.image1.canvas.Handle, OPAQUE);
  flimage1.image1.canvas.Font.assign(tmpTFont);
  DeleteObject(tmpF);
  tmpTFont.Free;
end;

procedure ecrit_coord_listbox;{
------------------------------}
var
  i        : integer;
  s,s1,s2  : string;
  x,y      : integer;
begin
    flimage1.listbox1.clear;
    flimage1.image1.picture.assign(clipboard);
    if(nobs > 0)then begin
      for i:=1 to nobs do begin
        str(i:2,s);
        x:=px_obs[i]+4;
        y:=py_obs[i];
        //flimage1.image1.canvas.textout(px_obs[i]+4,py_obs[i],s);
        ecrit_transparent(x,y,s);
        croix(px_obs[i],py_obs[i]);
        str(xobs[i]:5:2,s1);
        str(yobs[i]:5:2,s2);
        s:=s+' '+s1+' '+s2;
        flimage1.listbox1.items.Add(s);
      end;
    end;
end;

{Rappel du presse-papier pour effacer}
procedure gomme;{
----------------}
begin
     flimage1.image1.picture.Assign(ClipBoard);
end;

{Remise  zro des flag}
procedure reset_flag;{
---------------------}
begin
  flimage1.caption:='OrientExpress';
  flag_origine:=false;
  flag_mesure:=false;
  flag_scale:=false;
  flag_cercle:=false;
  flag_point:=false;
end;

{Trac d'un cercle sur 100 points}
procedure trace_cercle(x,y: integer);{
-------------------------------------}
var
   i   : integer;
begin
    flimage1.image1.canvas.pen.color:=clred;
    x_dernier:=x;
    y_dernier:=y;
    flimage1.image1.canvas.moveto(x+round(coordx[1]*rayon),
                                y+round(coordy[1]*rayon));
    for i:=2 to 100 do
    flimage1.image1.canvas.lineto(x+round(coordx[i]*rayon),
                                y+round(coordy[i]*rayon));
    flimage1.image1.canvas.pen.color:=clblack;
    //flimage1.refresh;
end;

{Ecriture sur l'image de l'origine et de l'chelle}
procedure display_panel4;{
-------------------------}
var
  s,s1  : string;
  nomf  : TextFile;
begin
  if(x_origine <> 0) or (y_origine <> 0)then begin
    flimage1.label1.enabled:=true;
    str(x_origine:4,s1);
    s:='Origin at '+s1;
    str(y_origine:4,s1);
    s:=s+' '+s1;
  end else begin
    s:='Unknown origin';
  end;
  flimage1.label1.caption:=s;

  if (nb_pixel_cm <> 0)then begin
    str(nb_pixel_cm:7:2,s1);
    s:='Nb pix./Cm:'+s1;
  end else begin
    s:='Unknown scale';
  end;
  flimage1.label3.caption:=s;
  if (nb_pixel_cm > 0) and (x_origine > 0) and (y_origine > 0)then begin
    AssignFile(nomf,'imageconst.txt');
    rewrite(nomf);
    writeln(nomf,nb_pixel_cm:7:2);
    writeln(nomf,x_origine:5,y_origine:5);
    closeFile(nomf);
    flimage1.measurecoord1.enabled:=true;
    flimage1.origin1.enabled:=true;
  end;

end;

{Effacement avec criture des coordonnes dans ListBox1}
procedure efface;{
-----------------}
var
   i,xw2,yw2   : integer;
   s,s1,s2     : string;
begin

  yw2:=20;
  xw2:=700;
  flimage1.image1.picture.Assign(ClipBoard);
  flimage1.listbox1.items.clear;
  if flag_mesure then begin
    flag:=1;
    ecrit_coord_listbox;
    (*if(nobs > 0)then begin
      for i:=1 to nobs do begin
        str(i:2,s);
        flimage1.image1.canvas.textout(px_obs[i]+4,py_obs[i],s);
        croix(px_obs[i],py_obs[i]);
        yw2:=yw2+15;
        str(xobs[i]:5:2,s1);
        str(yobs[i]:5:2,s2);
        s:=s+' '+s1+' '+s2;
        flimage1.listbox1.items.Add(s);
      end;
    end;*)
  end;
  if flag_scale then begin
    flag:=1;
    for i:= 1 to  nb_point_scale do begin
      croix(x_scale[i],y_scale[i]);
      yw2:=yw2+15;
      str(x_scale[i]:3,s1);
      str(y_scale[i]:3,s2);
      s:=s+' '+s1+' '+s2;
      flimage1.listbox1.items.add(s);
    end;
  end;
  if (x_origine <> 0) and (y_origine <> 0) then croix(x_origine,y_origine);
 end;

function lit(rang,nb_bytes: integer):integer;{
----------------------------------------------}
var
  contenu: integer;
begin
  contenu:=ord(tampon[rang])+256*ord(tampon[rang+1]);
  if(nb_bytes = 4)then contenu:=contenu+
  65536*ord(tampon[rang+2])+16777216*ord(tampon[rang+3]);
  lit:=contenu ;
end;

(*{Lecture du header du fichier nom_fichier_image}
procedure lit_header;{
---------------------}
var
  nomf    : File;
  result  : integer;

begin
  AssignFile(nomf,nom_fichier_image);
  reset(nomf);
  blockread(nomf,tampon,1,result);
  largeur_image:=lit(19,4);
  hauteur_image:=lit(23,4);
  closefile(nomf);
 end; *)


{Option File. Lecture du nom de fichier}
procedure Tflimage1.lecture_nom_fichier(Sender: TObject);{
--------------------------------------------}
var
  nomf      : textfile;
begin
   //OpenDialog1.filterIndex:=1;
   if OpenPictureDialog1.execute then begin
     nom_fichier_image:=OpenPictureDialog1.FileName;
     n_origine:=0;
     x_origine:=0;
     y_origine:=0;
     nb_pixel_cm:=0;
     xw:=2;
     yw:=2;
     display_panel4;
     scale1.enabled:=true;
     origin1.enabled:=true;
     measurecoord1.enabled:=true;
     savecoord1.enabled:=false;
     panel1.caption:='';
     panel4.visible:=true;

//voir delphi/composants/jpeg/test
     try
       Image1.Picture.LoadFromFile(nom_fichier_image);
     except
       on EInvalidGraphic do
         Image1.Picture.Graphic := nil;
     end;
     //SetJPEGOptions(self);
     ClipBoard.assign(image1.Picture);
     image1.picture.assign(clipboard);

//Sauvegarde de l'image en bmp
     if (pos('.jpg',nom_fichier_image) > 0)then begin
       image1.Picture.SaveToFile('dummy.bmp');
       image1.Picture.LoadFromFile('dummy.bmp');
       clipboard.clear;
       ClipBoard.assign(image1.Picture);
       image1.picture.assign(clipboard);
     end;

     flag_image:=true;
     if (no_appel <> 2)then nobs:=0;
     listbox1.clear;
     label1.visible:=true;
     label3.visible:=true;
     if fileExists('imageconst.txt') then begin
       AssignFile(nomf,'imageconst.txt');
       reset(nomf);
       readln(nomf,nb_pixel_cm);
       readln(nomf,x_origine,y_origine);
       closeFile(nomf);
       display_panel4;
     end;
     if (no_appel = 2)then begin
       return.enabled:=true;
       panel1.visible:=true;
       panel1.caption:=
       'OrientExpress. Superimposition of Laue image on the simulation picture.'
       +' Determine the origin and scale';
       Measurecoord1.enabled:=false;
     end;
  end;
end;

{$i dfm_limage.pas}
procedure Tflimage1.creation_fiche(Sender: TObject); {
-----------------------------------------------------}
begin
 // screen.Cursors[crMycursor]:=LoadCursorFromFile('showcur.cur');
  x_souris:=0;
  y_souris:=0;
  n_origine:=0;
  x_origine:=0;
  y_origine:=0;
  xw:=2;
  yw:=2;
//panel1.visible:=true;
  panel1.caption:='';
  panel2.visible:=false;
  panel3.visible:=false;
  panel1.visible:=false;
  panel4.visible:=false;
  panel6.visible:=false;
  nom_fichier_image:='';
  reset_flag;
  nb_point_scale:=0;
  scale1.enabled:=false;
  origin1.enabled:=false;
  measurecoord1.enabled:=false;
  savecoord1.enabled:=false;
  return.enabled:=false;
  flag:=1;
  if (screen.width = 800)then limage800;
end;

{Initialisation de la fiche}
procedure Tflimage1.initialise(Sender: TObject);{
------------------------------------------------}
var
//   s               : string;
   i               : integer;
   arg             : real;
//   nomf            : textFile;
begin
  if (angle <> 0)then fitellipse1.enabled:=false else fitellipse1.enabled:=true;
  top:=0;left:=0;
  cursor:=crcross;
  if (length(nom_fichier_image) > 0) then begin
     //image1.Picture.LoadFromFile(nom_fichier_image);
     //ClipBoard.assign(image1.Picture);
  end else begin
    lecture_nom_fichier(Sender);
  end;
  arg:=2*pi/99;
  for i:=1 to 100 do begin
    coordx[i]:=cos(arg*(i-1));
    coordy[i]:=sin(arg*(i-1));
  end;
  rayon:=14;
  trackbar1.position:=rayon;
  delta:=1;
  reset_flag;

  measurecoord1.enabled:=false;
  savecoord1.enabled:=false;
  display_panel4;
  panel5.visible:=false;
  ListBox1.visible:=false;

  flag:=1;
  if (nb_pixel_cm = 0) then begin
      origin1.enabled:=false;
  end else begin
      origin1.enabled:=true;
      if (x_origine > 0) and (y_origine > 0) then measurecoord1.enabled:=true;
  end;

  if(no_appel = 2)  and (length(nom_fichier_image) = 0) then begin
      //fdessin.visible:=false;
      lecture_nom_fichier(sender);
  end;

end;

//Mesure des coordonnes par pointage 
procedure pique_coord(x,y : integer);{
--------------------------------------}
var
//   tableau                            : array [-50..50,-50..50] of longint;
//   y1,y2,y3,y4,ak,al,den              : integer;
   i,j                                  : integer;
//   s,s1                                 : string;

begin
     flag:=1;
     i:=x;
     j:=y;
{stockage des coordonnes mesures}
     nobs:=nobs+1;
     xobs[nobs]:=(i-x_origine)/nb_pixel_cm;
     yobs[nobs]:=-(j-y_origine)/nb_pixel_cm;
     px_obs[nobs]:=i;
     py_obs[nobs]:=j;
{On efface le zoom}
     flimage1.panel1.caption:=
     'Click on the spots then save the coordinates. (right button to delete one spot)';
     flimage1.panel1.visible:=true;
     ecrit_coord_listbox;
end;

{Mesure de l'chelle en cliquant sur 2 points}
procedure mesure_scale(x,y : integer);{
--------------------------------------}
var
// tableau                              : array [-50..50,-50..50] of longint;
//   y1,y2,y3,y4,ak,al,den              : integer;
   i,j                                  : integer;
   s,s1                                 : string;

begin
     flag:=1;
//   flimage1.panel1.caption:='Click on the point';
     i:=x;
     j:=y;

     nb_point_scale:=nb_point_scale+1;
     x_scale[nb_point_scale]:=i;
     y_scale[nb_point_scale]:=j;

     str(nb_point_scale:2,s);
     str(i:4,s1);
     s:=s+s1;
     str(j:4,s1);
     s:=s+s1;
     flimage1.ListBox1.items.add(s);
     for i:=1 to nb_point_scale do croix(x_scale[i],y_scale[i]);

     if (nb_point_scale = 2) then begin
       reset_flag;
       if (x_origine <> 0) and (y_origine <> 0) then
       flimage1.Measurecoord1.enabled:=true;
       flimage1.panel3.visible:=true;
       flimage1.panel3.enabled:=true;
       flimage1.panel1.visible:=false;
       exit;
     end;
end;

{Pointage du faisceau direct pour mesure de l'origine}
procedure clique_trace_faisceau(x,y : integer);{
-----------------------------------------------}
var
  ix              : integer;
begin
     x_origine:=x;
     y_origine:=y;
     if (no_appel = 2)then begin
       flimage1.measurecoord1.enabled:=false;
       flimage1.savecoord1.enabled:=false;
       flimage1.return.enabled:=true;
     end;
     reset_flag;
     gomme;
     ix:=4;
     petit_cercle(x,y,ix);
     if (nb_pixel_cm <> 0) and (no_appel = 1)
     then flimage1.Measurecoord1.enabled:=true;
     display_panel4;
     flimage1.panel1.caption:='';
     flimage1.panel1.visible:=false;;
end;

{Gestion de l'venement on mouse down}
procedure Tflimage1.pointe(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
-----------------------------------------------------------------}
var
  i,n                        : integer;
begin
   mouse_down:=true;
   x_down:=x;
   y_down:=y;

//Mesure de coodonnes
   if flag_mesure then  begin
     if (button = mbleft)then  pique_coord(x,y);  {mesure}
     if (button = mbright) then begin              {effacement}
       if(nobs = 0)then exit;
       for i:=1 to nobs do begin
         if (abs(px_obs[i]-x) < 3) and (abs(py_obs[i]-y) < 3) then begin
           xobs[i]:=0;
           yobs[i]:=0;
           px_obs[i]:=0;
           py_obs[i]:=0
         end;
       end;
       n:=0;
       for i:=1 to nobs do begin
         if(xobs[i] = 0) and (yobs[i] = 0)then continue;
         n:=n+1;
         xobs[n]:=xobs[i];
         yobs[n]:=yobs[i];
         px_obs[n]:=px_obs[i];
         py_obs[n]:=py_obs[i];
       end;
       nobs:=n;
       ecrit_coord_listbox;
     end;
   end;

//Mesure echelle
   if flag_scale then begin
     nb_pixel_cm:=0;
     gomme;
     listbox1.visible:=true;
     mesure_scale(x,y)
   end;
//
   if flag_point then begin
     caption:='OrientExpress. ';
     x_origine:=0;
     y_origine:=0;
     gomme;
     clique_trace_faisceau(x,y);
   end;
end;

{Option Coord. Measure. Mesure des coordonnes}
procedure Tflimage1.mesure_coordonnees(Sender: TObject);{
--------------------------------------------------------}
begin
//  screen.cursor:=crMycursor;
//  screen.cursor:=crdefault;
//     Bmp := TBitmap.Create;
//     bmp.assign(clipboard);
  if flag_origine or flag_point or flag_cercle then begin
    erreur('Please desactive Origin determination');
    exit;
  end;
  reset_flag;
  ListBox1.visible:=true;
  caption:='OrientExpress. Coordinates measurement process';
  flag_mesure:=true;
  flag:=1;
  Savecoord1.enabled:=true;
  panel5.visible:=false;
  image2.visible:=true;
  panel1.caption:=
  'Click on the spots then save the coordinates. (right button to delete one spot)';
  panel1.visible:=true;
end;

{Option Save coord.}
procedure Tflimage1.sauve_coord(Sender: TObject);{
-------------------------------------------------}
var
  nomf                  : TextFile;
  i                     : integer;
  w                     : word;
begin
   reset_flag;
//   screen.cursor:=crdefault;
   if(nobs> 0) then begin
     panel1.visible:=false;
     if SaveDialog1.execute then begin
       nom_fichier_coord:=SaveDialog1.FileName;
       if (pos('.coo',nom_fichier_coord) = 0)
       then nom_fichier_coord:=nom_fichier_coord+'.coo';
       if FileExists(nom_fichier_coord) then begin
         //beep;
         w:=messageDlg('This file already exists. Do you want to continue?',
         mtConfirmation,mbYesNoCancel,0);
         if (w = mrNo) or (w = mrAbort) then exit;
     end;
     AssignFile(nomf,Nom_fichier_coord);
       Rewrite(nomf);
       for i:=1 to nobs do writeln(nomf,xobs[i]:10:3,yobs[i]:10:3);
       Closefile(nomf);
       panel1.caption:='';
       return.enabled:=true;
       quitter(Sender);
     end;
   end;
//   bmp.free;
end;

{Option mesure de l'chelle}
procedure Tflimage1.mesure_echelle_regle(Sender: TObject);{
------------------------------------------------------}
begin
  reset_flag;
  caption:='OrientExpress. Scale measurement';
  panel5.visible:=false;
  flag_scale:=true;
  listbox1.items.clear;
  listbox1.visible:=true;
  panel1.caption:='Click on two points and give the distance in cm';
  panel1.visible:=true;
end;

{Lecture de la distance entre traits pour dterminer l'echelle (Edit1)}
procedure Tflimage1.lecture_distance(Sender: TObject);{
-------------------------------------------------}
var
  d,xx,yy                : real;
  ier                    : integer;
begin
  val(edit1.text,d,ier);
  xx:=x_scale[1]-x_scale[2];
  yy:=y_scale[1]-y_scale[2];
  if(ier = 0)then begin
    nb_pixel_cm:=sqrt(xx*xx+yy*yy)/d;
    origin1.enabled:=true;
    listbox1.items.clear;
    listbox1.visible:=false;
    hauteur_image:=round(hauteur*nb_pixel_cm);
    largeur_image:=round(largeur*nb_pixel_cm);
    flag_scale:=false;
    panel1.caption:='';
    nb_point_scale:=0;
    image1.picture.Assign(ClipBoard);
    display_panel4;
    panel3.visible:=false;
    reset_flag;
    {caption:='OrientExpress'}
  end else begin
    edit1.setfocus;
  end;
end;

{Option Lecture entre chelle au clavier}
procedure Tflimage1.entree_echelle_clavier(Sender: TObject);{
---------------------------------------------------}
begin
  caption:='OrientExpress. Scale acquisition';
  panel5.visible:=false;
 
  panel2.visible:=true;
  edit2.setfocus;
end;

{lecture chelle donne par l'utilisateur dans Edit2.
Evnement OnClick OK button2}
procedure Tflimage1.oklecture_echelle(Sender: TObject);{
------------------------------------------------------}
var
  ier     : integer;
  s       : string;
begin
  val(edit2.text,nb_pixel_cm,ier);
  if( ier = 0 ) then begin
    hauteur_image:=round(hauteur*nb_pixel_cm);
    largeur_image:=round(largeur*nb_pixel_cm);
    origin1.enabled:=true;
    panel2.visible:=false;
    str(nb_pixel_cm:7:2,s);
    image1.picture.Assign(ClipBoard);
    display_panel4;
    {flag_scale:=false;}
    reset_flag;
    panel1.caption:='';
    nb_point_scale:=0;
    if (x_origine <> 0) and (y_origine <> 0) then
    flimage1.Measurecoord1.enabled:=true;
  end else begin
    edit2.setfocus;
  end;
end;

//Option Origine /Point}
procedure Tflimage1.Mode_Origine_point(Sender: TObject);{
---------------------------------------------------}
begin
    beep;
    reset_flag;
    flag_point:=true;
    //flag_origine:=true;
    caption:='OrientExpress. Origin determination ';
    x_origine:=0;
    y_origine:=0;
    ListBox1.visible:=false;
    panel5.visible:=false;
    panel1.visible:=true;
    panel1.caption:='Origin determination by point. Click on the center of the diagram';
    gomme;
    beep;
end;

//Option Origine cercle
procedure Tflimage1.mode_Origine_cercle(Sender: TObject);{
----------------------------------------------------}
var
  x,y  : integer;
begin
   beep;
   reset_flag;
   caption:='OrientExpress. Origin determination';
   x_origine:=0;
   y_origine:=0;
   x:=image1.width div 2;
   y:=image1.height div 2;
   trace_cercle(x,y);
   flag_cercle:=true;
   flag_origine:=true;
   panel5.visible:=true;
   caption:='OrientExpress. Origin determination';
   ListBox1.visible:=false;
   panel1.caption:=
   'Press the left button and Drag the circle with left button down. Possibly adjust the radius,'
   +' then click on the OK button';
   panel1.visible:=true;
   beep;
end;

{gestion de l'vnement OnMouseMove}
procedure Tflimage1.deplace_souris(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);{
-------------------------------------------------------------------------}
var
  s,s1                     : string;
//  x_rect,y_rect,i,j        : integer;
begin
 (* if flag_mesure then begin
    image1.picture.Assign(ClipBoard);
    with image1.Canvas do begin
      pen.color:=clred;
      //pen.width:=3;
      moveto(x-9,y);lineto(x+9,y);
      moveto(x,y-9);lineto(x,y+9);
    end;
  end; *)
(*if flag_mesure then begin
   with image1.canvas do begin
     for i:=1 to 41 do begin
       j:=x_souris+i-21;
       pixels[j,y_souris]:=ligne[i];
       j:=y_souris+i-21;
       pixels[x_souris,j]:=colonne[i];
     end;
     for i:=1 to 41 do begin
       j:=x+i-21;
       ligne[i]:=pixels[j,y];
       j:=y+i-21;
       colonne[i]:=pixels[x,j];
     end;
     pen.color:=clred;
     //pen.width:=1;
     moveto(x-20,y);lineto(x+20,y);
     moveto(x,y-20);lineto(x,y+20);
   end;
   x_souris:=x;
   y_souris:=y;
 end;  *)

//Essai bmp
   (*if flag_mesure then begin
       with image1.canvas do begin
         Draw(0,0,bmp);
         pen.color:=clred;
         MoveTo(x-20,y);
         lineto(x+20,y);
         moveto(x,y-20);
         lineto(x,y+20);
       end;
       //exit;
   end;

 (*
    image1.canvas.pen.color:=clred;
    for i:=0 to image1.width-1 do image1.canvas.pixels[i,y_souris]:=ligne[i];
    for i:=0 to image1.height-1 do image1.canvas.pixels[x_souris,i]:=colonne[i];
    for i:=0 to image1.width-1 do ligne[i]:=image1.canvas.pixels[i,y];
    for i:=0 to image1.height-1 do colonne[i]:=image1.canvas.pixels[x,i];
    image1.Canvas.MoveTo(0,y);image1.Canvas.lineTo(image1.width-1,y);
    image1.Canvas.MoveTo(x,0);image1.Canvas.lineTo(x,image1.height-1);
    x_souris:=x;
    y_souris:=y;
    *)
  //end;

  if flag_cercle and flag_origine and mouse_down then begin
    image1.picture.Assign(ClipBoard);
    str(x:4,s);
    str(y:4,s1);
    s:=s+s1;
    trace_cercle(x,y);
    x_origine:=x;
    y_origine:=y;
  end;
  (*x_rect:=700;
  y_rect:=500;
  str(x:4,s);
  str(y:4,s1);
  s:=s+s1;
  flimage1.canvas.textout(x_rect+3,y_rect+5,s); *)

//Image2
  with image2.canvas do begin
      copyrect(rect(0,0,80,80),flimage1.image1.canvas,rect(x-20,y-20,x+20,y+20));
      copyrect(rect(0,0,80,80),flimage1.image1.canvas,rect(x-20,y-20,x+20,y+20));
      pen.color:=clred;
      moveto(1,1);
      lineto(79,1);
      lineto(79,79);
      lineto(1,79);
      lineto(1,1);
      moveto(20,40);
      lineto(60,40);
      moveto(40,20);
      lineto(40,60);
      pen.color:=clblack;
  end;
end;

procedure Tflimage1.Aide_bitmap(Sender: TObject); {
--------------------------------------------------}
begin
    Application.HelpFile:='OrientExpress.hlp';
    Application.HelpContext(3);
end;

{Effacemet des paneaux 2 et 3}
procedure Tflimage1.cancel_panel2(Sender: TObject);{
---------------------------------------------------}
begin
  panel2.visible:=false;
  panel3.visible:=false;
  panel6.visible:=false;
end;

procedure Tflimage1.abandon(Sender: TObject);{
---------------------------------------------}
begin
{On raze le presse papier}
  clipboard.clear;
{On raze l'image1}
  image1.canvas.rectangle(1,1,image1.width,image1.height);
{On raze le nom du fichier}
  nom_fichier_image:='';
  flag_image:=false;
  measurecoord1.enabled:=false;
  savecoord1.enabled:=false;
{clipboard.clear;}
  close;
end;

procedure Tflimage1.quitter(Sender: TObject);{
--------------------------------------------}
begin
  measurecoord1.enabled:=false;
  savecoord1.enabled:=false;
  if (no_appel = 2)then begin
    fdessin.visible:=true;
  end;
  close;
end;

{Accroissement du rayon du cercle pour dtermination de l'origine (button5)}
procedure Tflimage1.rayon_croit(Sender: TObject);{
-------------------------------------------------}
begin
  rayon:=rayon+1;
  flag_origine:=true;
  gomme;
  if(x_origine <> 0) and (y_origine <> 0) then trace_cercle(x_origine,y_origine);
end;

{Diminution du rayon du cercle pour dtermination de l'origine (button6)}
procedure Tflimage1.rayon_decroit(Sender: TObject);{
---------------------------------------------------}
begin
  rayon:=rayon-1;
  flag_origine:=true;
  gomme;
  if(x_origine <> 0) and (y_origine <> 0) then trace_cercle(x_origine,y_origine);
end;

procedure Tflimage1.fit_ellipse(Sender: TObject);{
-------------------------------------------------}
begin
  ffitellipse.visible:=true;
end;

procedure Tflimage1.entree_origine(Sender: TObject);{
----------------------------------------------------}
begin
  panel6.visible:=true;
  edit3.setfocus;
end;

procedure Tflimage1.lecture_origine(Sender: TObject);{
-----------------------------------------------------}
var
   s   : string;
   ier : integer;
begin
  s:=edit3.text;
  val(s,x_origine,ier);
  if (ier > 0)then begin
    erreur('Origin read error');
    exit;
  end;
  s:=edit4.text;
  val(s,y_origine,ier);
  if (ier > 0)then begin
    erreur('Origin read error');
    exit;
  end;
  display_panel4;
  panel6.visible:=false;
end;

procedure Tflimage1.move_rayon(Sender: TObject);
//----------------------------------------------
begin
  rayon:=trackbar1.position;
  //flag_origine:=true;
  gomme;
  //if(x_origine <> 0) and (y_origine <> 0) then
  trace_cercle(x_origine,y_origine);
end;

procedure Tflimage1.cancel_cercle(Sender: TObject);
//--------------------------------------------------
begin
  panel5.visible:=false;
  flag_origine:=false;
end;

procedure Tflimage1.OK_origine_cercle(Sender: TObject);
//-----------------------------------------------------
var
  i   : integer;
begin
  if flag_cercle then begin
    reset_flag;
    i:=4;
    petit_cercle(x_origine,y_origine,i);
    display_panel4;
    if (nb_pixel_cm <> 0)then flimage1.Measurecoord1.enabled:=true;
    panel5.visible:=false;
    panel1.visible:=false;
  end;
end;

procedure Tflimage1.onmouse_up(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//-------------------------------------------------------------------
begin
  mouse_down:=false;
end;

//Effacement-reset des reflexions slectionnes
procedure Tflimage1.Resetcoord1Click(Sender: TObject);
//---------------------------------------------------
begin
  nobs:=0;
  listbox1.clear;
  //Image1.Picture.LoadFromFile(nom_fichier_image);
//voir delphi/composants/jpeg/test
     try
       Image1.Picture.LoadFromFile(nom_fichier_image);
     except
       on EInvalidGraphic do
         Image1.Picture.Graphic := nil;
     end;
     //SetJPEGOptions(self);
     ClipBoard.assign(image1.Picture);
     image1.picture.assign(clipboard);

//Sauvegarde de l'image en bmp
     if (pos('.jpg',nom_fichier_image) > 0)then begin
       image1.Picture.SaveToFile('dummy.bmp');
       image1.Picture.LoadFromFile('dummy.bmp');
       clipboard.clear;
       ClipBoard.assign(image1.Picture);
       image1.picture.assign(clipboard);
     end;
end;

end.
