{Acquisition de la matrice d'orientation}
unit Limat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, oemath, Buttons;

type
  Tflimat = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label3: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    edit0: TEdit;
    button1: TBitBtn;
    button2: TBitBtn;
    BitBtn1: TBitBtn;
    procedure Abandon(Sender: TObject);
    procedure validation(Sender: TObject);
    procedure Aide_matrice(Sender: TObject);
    procedure verifie(Sender: TObject);
    procedure init_first(Sender: TObject);
    procedure ferme(Sender: TObject);
    procedure toto(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

procedure initialise_zero;
Procedure calcmat         (var rpqr :matrice3; var ier:integer);
Procedure matrois         (var i1,i2,ier : integer);

var
  flimat: Tflimat;
  reseaux,reseauy,reseauz,ier  :integer;
  px,qx,rx,py,qy,ry,pz,qz,rz   :real;
{  nomfich                      :textFile;}

implementation

{$R *.DFM}

procedure Tflimat.Abandon(Sender: TObject);
begin
  message_matrice:='';
  flimat.visible:=false;
end;

procedure Tflimat.validation(Sender: TObject);
var
  rpqr                         :matrice3;
  som,x,y,z                    :real;
  i                            :integer;

begin
  verifie(sender);
  {Axe OX}
  som:=abs(px)+abs(qx)+abs(rx);
  if(som <> 0)then begin
    if(reseaux = 0)then begin
      normd(px,qx,rx);
      r31[1,1]:=px;
      r31[1,2]:=qx;
      r31[1,3]:=rx;
      trfo(px,qx,rx,x,y,z,r10);
      r13[1,1]:=x;
      r13[2,1]:=y;
      r13[3,1]:=z;
    end;
    if(reseaux = 1)then begin
      normr(px,qx,rx);
      r13[1,1]:=px;
      r13[2,1]:=qx;
      r13[3,1]:=rx;
      trfo(px,qx,rx,x,y,z,r01);
      r31[1,1]:=x;
      r31[1,2]:=y;
      r31[1,3]:=z;
    end;
  end;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[1,i]:=0;
      r31[1,i]:=0;
    end;
  end;

  {Axe OY}
  som:=abs(py)+abs(qy)+abs(ry);
  if(som <> 0)then begin
    if(reseauy = 0)then begin
      normd(py,qy,ry);
      r31[2,1]:=py;
      r31[2,2]:=qy;
      r31[2,3]:=ry;
      trfo(py,qy,ry,r13[1,2],r13[2,2],r13[3,2],r10);
    end;
    if(reseauy = 1)then begin
      normr(py,qy,ry);
      r13[1,2]:=py;
      r13[2,2]:=qy;
      r13[3,2]:=ry;
      trfo(py,qy,ry,r31[2,1],r31[2,2],r31[2,3],r01);
    end;
  end ;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[2,i]:=0;
      r31[2,i]:=0;
    end;
  end;
  {Axe OZ}
  som:=abs(pz)+abs(qz)+abs(rz);
  if(som <> 0)then begin
    if(reseauz = 0)then begin
      normd(pz,qz,rz);
      r31[3,1]:=pz;
      r31[3,2]:=qz;
      r31[3,3]:=rz;
      trfo(pz,qz,rz,r13[1,3],r13[2,3],r13[3,3],r10);
    end;
    if(reseauz = 1)then begin
      normr(pz,qz,rz);
      r13[1,3]:=pz;
      r13[2,3]:=qz;
      r13[3,3]:=rz;
      trfo(pz,qz,rz,r31[3,1],r31[3,2],r31[3,3],r01);
    end;
  end;
  if(som = 0)then begin
    for i:=1 to 3 do begin
      r13[3,i]:=0;
      r31[3,i]:=0;
    end;
  end;

  rpqr[1,1]:=px;
  rpqr[1,2]:=qx;
  rpqr[1,3]:=rx;

  rpqr[2,1]:=py;
  rpqr[2,2]:=qy;
  rpqr[2,3]:=ry;

  rpqr[3,1]:=pz;
  rpqr[3,2]:=qz;
  rpqr[3,3]:=rz;

  calcmat (rpqr,ier);
  if (ier = 1) then exit;

 {code_data_dll};
  message_matrice:='Matrix defined by the user';
  nsol:=0;
  no_sol:=0;
  conditionne_matrice;
  ident(r13,r13_old);
  close;
end;

procedure initialise_zero;
begin
  flimat.radiogroup1.itemIndex:=0;
  flimat.radiogroup2.itemIndex:=1;
  flimat.radiogroup3.itemIndex:=1;
  flimat.edit0.text:='0';
  flimat.edit1.text:='0';
  flimat.edit2.text:='0';
  flimat.edit3.text:='0';
  flimat.edit4.text:='0';
  flimat.edit5.text:='0';
  flimat.edit6.text:='0';
  flimat.edit7.text:='0';
  flimat.edit8.text:='0';
end;

procedure Tflimat.Aide_matrice(Sender: TObject);
begin
   Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(5);
end;

procedure Tflimat.verifie(Sender: TObject);
var
 chaine: string;

begin
  chaine:=edit0.text;
  if(length(chaine) <> 0)then begin
  add_zero(chaine);
    val(chaine,px,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit0.text:='';
    end;
  end
  else px:=0;

  chaine:=edit1.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit1.text:='';
    end;
  end
  else qx:=0;

  chaine:=edit2.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rx,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit2.text:='';
    end;
  end
  else rx:=0;

  chaine:=edit3.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,py,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit3.text:='';
    end;
  end
  else py:=0;

  chaine:=edit4.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qy,ier);
    if(ier <> 0)then begin
      erreur ('Type error'); edit4.text:='';
    end;
  end
  else qy:=0;

  chaine:=edit5.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,ry,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit5.text:='';
    end;
  end
  else ry:=0;

  chaine:=edit6.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,pz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit6.text:='';
    end;
  end
  else pz:=0;

  chaine:=edit7.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,qz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit7.text:='';
    end;
  end
  else qz:=0;

  chaine:=edit8.text;
  if(length(chaine) <> 0)then begin
    add_zero(chaine);
    val(chaine,rz,ier);
    if(ier <> 0)then begin
      erreur ('Type error');
      edit8.text:='';
    end;
  end
  else rz:=0;

  reseaux:=radiogroup1.ItemIndex;
  reseauy:=radiogroup2.ItemIndex;
  reseauz:=radiogroup3.ItemIndex;

end;


procedure Tflimat.init_first(Sender: TObject);
begin
 { flimat.top:=(screen.height div 2)-240;
  flimat.left:=(screen.width div 2)-320;}
  initialise_zero;
  edit0.setfocus;
  left:=10;
  top:=40;
  {assignFile(nomfich,'espion.txt');
  rewrite(nomfich);}
end;

procedure Tflimat.ferme(Sender: TObject);
begin
 { closefile(nomfich);}
end;

procedure Tflimat.toto(Sender: TObject);
begin
 { flimat.top:=(screen.height div 2)-240;
  flimat.left:=(screen.width div 2)-320;}
end;

end.

