{Rotation autour des axes. calcul de la nouvelle matrice}
unit Matrot;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  Tfmatrot = class(TForm)
    Bevel1: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    CancelBtn: TBitBtn;
    button1: TBitBtn;
    Image1: TImage;
    procedure lit_angles(Sender: TObject);
    procedure annule_angles(Sender: TObject);
    procedure verif_angles(Sender: TObject);
    procedure init(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmatrot           : Tfmatrot;
  phix,phiy,phiz  : single;


implementation

{$R *.DFM}
uses
  oemath;
  
procedure Tfmatrot.lit_angles(Sender: TObject);
var
  mx,my,mz,aux,aux2: matrice3;
  co,si            : single;
begin
  verif_angles(sender);
//Rotation autour de OX}
  co:=cos(phix/57.2957);
  si:=sin(phix/57.2957);
  mx[1,1]:=1;
  mx[1,2]:=0;
  mx[1,3]:=0;
  mx[2,1]:=0;
  mx[2,2]:=co;
  mx[2,3]:=-si;
  mx[3,1]:=0;
  mx[3,2]:=si;
  mx[3,3]:=co;
//Rotation autour de OY}
  co:=cos(phiy/57.2957);
  si:=sin(phiy/57.2957);
  my[1,1]:=co;
  my[1,2]:=0;
  my[1,3]:=si;
  my[2,1]:=0;
  my[2,2]:=1;
  my[2,3]:=0;
  my[3,1]:=-si;
  my[3,2]:=0;
  my[3,3]:=co;
  {Rotation autour de OZ}
  co:=cos(phiz/57.2957);
  si:=sin(phiz/57.2957);
  mz[1,1]:=co;
  mz[1,2]:=-si;
  mz[1,3]:=0;
  mz[2,1]:=si;
  mz[2,2]:=co;
  mz[2,3]:=0;
  mz[3,1]:=0;
  mz[3,2]:=0;
  mz[3,3]:=1;
  mat_mult(my,mx,aux);
  mat_mult(mz,aux,aux2);
  mat_mult(aux2,r31,aux);
  ident(aux,r31);
  matinv(r31,r13);
  mat_mult(r21,r13,r23);
  mat_mult(r31,r12,r32);
  {ecrit_donnees;}
  {code_data_dll};
  if(phix <> 0) or (phiy <> 0) or (phiz <> 0)then begin
    message_matrice:='Orientation matrix after rotation';
    {ident(r13,r13_old);}
  end;
  close;
end;

procedure Tfmatrot.annule_angles(Sender: TObject);
begin
  phix:=0.;
  phiy:=0.;
  phiz:=0.;
  fmatrot.visible:=false;
end;

procedure Tfmatrot.verif_angles(Sender: TObject);
var
  s       :string;
  ier     :integer;
begin
  fmatrot.edit1.color:=clwhite;
  s:= fmatrot.edit1.text;
  add_zero(s);
  if(length(s) > 0)then begin
    val(s,phix,ier);
    if(ier > 0)then begin
      fmatrot.edit1.color:=clred;
      edit1.setfocus;
      erreur('Erreur de frappe');
      exit;
    end;
  end else phix:=0;

  fmatrot.edit2.color:=clwhite;
  s:= fmatrot.edit2.text;
  add_zero(s);
  if(length(s) > 0)then begin
    val(s,phiy,ier);
    if(ier > 0)then begin
      fmatrot.edit2.color:=clred;
      edit2.setfocus;
      erreur('Erreur de frappe');
      exit;
    end;
  end else phiy:=0;

  fmatrot.edit3.color:=clwhite;
  s:= fmatrot.edit3.text;
  add_zero(s);
  if(length(s) > 0)then begin
    val(s,phiz,ier);
    if(ier > 0)then begin
      fmatrot.edit3.color:=clred;
      edit3.setfocus;
      erreur('Erreur de frappe');
      exit;
    end;
  end else phiz:=0;

end;

procedure Tfmatrot.init(Sender: TObject);
 var s:string;
begin
  {fmatrot.top:=(screen.height div 2)-240;
  fmatrot.left:=(screen.width div 2)-320;}
  str(phix:6:2,s);
  edit1.text:=s;
  str(phiy:6:2,s);
  edit2.text:=s;
  str(phiz:6:2,s);
  edit3.text:=s;
end;

end.
