{Ecran principal. gestion du menenu }
unit Mainmenu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Printers, StdCtrls, ExtCtrls, Grids, clipbrd,
  Buttons, ComCtrls, math, degradeur;

type
  Tfoemenu = class(TForm)
    MainMenu1: TMainMenu;
    Donnes1: TMenuItem;
    Fichier1: TMenuItem;
    Ecran1: TMenuItem;
    Panel2: TPanel;
    StringGrid1: TStringGrid;
    Coordonnes1: TMenuItem;
    Indexation1: TMenuItem;
    Matrice1: TMenuItem;
    Impression1: TMenuItem;
    Restauration1: TMenuItem;
    Rotation1: TMenuItem;
    Affinement1: TMenuItem;
    Acquisition1: TMenuItem;
    Simulation1: TMenuItem;
    fichier2: TMenuItem;
    Crer1: TMenuItem;
    Panel3: TPanel;
    Panel4: TPanel;
    OpenDialog1: TOpenDialog;
    Reorientation1: TMenuItem;
    APropos1: TMenuItem;
    Laue1: TMenuItem;
    Stereo1: TMenuItem;
    Save1: TMenuItem;
    Panel5: TPanel;
    ScanerPicture1: TMenuItem;
    Help1: TMenuItem;
    help2: TMenuItem;
    Quit1: TMenuItem;
    Edit23: TEdit;
    Label18: TLabel;
    Panel7: TPanel;
    Label4: TLabel;
    panel0: TPanel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    Label14: TLabel;
    ListBox1: TListBox;
    Panel9: TPanel;
    Image2: TImage;
    Label2: TLabel;
    Label21: TLabel;
    PrintDialog1: TPrintDialog;
    UpDown1: TUpDown;
    Label22: TLabel;
    Edit1: TMenuItem;
    Digitazer1: TMenuItem;
    Modification2: TMenuItem;
    Coordlist1: TMenuItem;
    Imageconst1: TMenuItem;
    Panel1: TPanel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    ListBox3: TListBox;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit36: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    Edit8: TEdit;
    Edit42: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit45: TEdit;
    Edit46: TEdit;
    Edit20: TEdit;
    Edit48: TEdit;
    Edit49: TEdit;
    Edit50: TEdit;
    Edit9: TEdit;
    Edit52: TEdit;
    Edit13: TEdit;
    Edit54: TEdit;
    Edit18: TEdit;
    Edit56: TEdit;
    RadioGroup1: TRadioGroup;
    Edit57: TEdit;
    Edit58: TEdit;
    Label27: TLabel;
    Edit59: TEdit;
    SaveDialog1: TSaveDialog;
    Panel6: TPanel;
    Memo1: TMemo;
    BitBtn5: TBitBtn;
    Panel10: TPanel;
    label1: TLabel;
    Label20: TLabel;
    Image1: TImage;
    Bevel3: TBevel;
    Panel11: TPanel;
    RadioGroup2: TRadioGroup;
    Label10: TLabel;
    Label11: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure sortie    (Sender: TObject);
    procedure Ecran1Click(Sender: TObject);
    procedure Fichier1Click(Sender: TObject);
    procedure Acquisition1Click(Sender: TObject);
    procedure simule_laue(Sender: TObject);
    procedure AproposClick(Sender: TObject);
    procedure Rotation1Click(Sender: TObject);
    procedure ecriture_panneaux(Sender: TObject);
    procedure Initialise_first(Sender: TObject);
    procedure reorientation(Sender: TObject);
    procedure Imprime_matrice(Sender: TObject);
    procedure simule_stereo(Sender: TObject);
    procedure editeur(Sender: TObject);
    procedure coordon_fichier(Sender: TObject);
    procedure coordon_clavier(Sender: TObject);
    procedure calcul(Sender: TObject);
    procedure restaure_matrice(Sender: TObject);
    procedure afine_vectoriel(Sender: TObject);
    procedure dispal_solution(Sender: TObject);
    procedure coordon_scanner(Sender: TObject);
    procedure Affiche_aide(Sender: TObject);
    procedure modif_coordonnees(Sender: TObject);
    procedure selecte_solution(Sender: TObject);
    procedure lecture_coordonnees(Sender: TObject);
    procedure help_general(Sender: TObject);
    procedure simule_stereon(Sender: TObject);
    procedure change_rayon(Sender: TObject; Button: TUDBtnType);
    procedure sauve_donnees(Sender: TObject);
    procedure Imageconst1Click(Sender: TObject);
    procedure coordon_digitaliseur(Sender: TObject);
    procedure degrade_form1(Sender: TObject);
    procedure verif_groupe(Sender: TObject);
    procedure no_entree(Sender: TObject);
    procedure lit_case(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure abandon_donnees(Sender: TObject);
    procedure valide_data(Sender: TObject);
    procedure entree_coordonnees(Sender: TObject);
    procedure sortie_distance(Sender: TObject);
    procedure cancel_redraw(Sender: TObject);
    procedure ok_redraw(Sender: TObject);
    procedure peint_cellule1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure toto(Sender: TObject);
    procedure reecrit_solutions(Sender: TObject);
    procedure voir_panel6(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    procedure DisplayHint(sender: TObject);
  end;

var
  foemenu         : Tfoemenu;

implementation

{$R *.DFM}

uses
  limat, apropos,
  matrot, {gener_ind,}dessin, oemath, reorient,
  coordon, calcul,
  afine, affivec, limage1, modifimage, digital, Affivec2, hexatorhom;

var
  no_case             : integer;

const
lbIndex : Integer = 1;
code_c : Word = 2685 ;

type
  LectureBlock = packed record
    value0 : Byte;
    value1 : Byte;
end;

var
  rayon_ellipse,updown_avant  : integer;


procedure test_groupe;
//--------------------
var
  Nomf                        : TextFile;
  s,groupe                    : string;

begin
 with foemenu do begin
   groupe_espace:=uppercase(edit20.text);
   groupe_espace:=trimright(groupe_espace);
   groupe_espace:=trimleft(groupe_espace);
   edit20.text:=groupe_espace;

   if(groupe_espace = '')then begin
      groupe_espace:='P-1';
      edit20.text:='P-1';
      edit20.font.color:=clred;
      exit;
   end;
   AssignFile(nomf,'orientexpress.grp');
   reset(nomf);
   groupe:=copy(groupe_espace,2,12);
   groupe:=trimleft(groupe);

   {Ce groupe exite-il dans le fichier OrientExpress.grp?}
   while (not eof(nomf)) do begin
     readln(nomf,s);
     s:=trimleft(s);
     if(s = '')then continue;
     if(s =  groupe)then begin
       edit20.font.color:=clblue;
       message_groupe:='';
       closeFile(nomf);
       exit;
     end;
   end;

   message_groupe:=
  'Unknown space group or no general extinction (except Bravais lattice)';
   closeFile(nomf);
  end;
end;

procedure relit_data (var ier:integer);
//-------------------------------------
var
i                         : integer;
s                         : string;
nomf                      : TextFile;
delta                     : real;

begin

  with foemenu do begin
    if (panel1.visible = false)then begin
      ier:=1;
      exit;
    end;
    ier:=0;

//Lecture du systme
    i:=listbox3.itemIndex;
    if (i >= 0)then begin
      systeme:=listbox3.items[i];
      systeme:=uppercase(copy(systeme,1,4));
    end else ier:=1;

//rseau de Bravais
    if (groupe_espace <> '')then begin
      bravais:=uppercase(copy(groupe_espace,1,1));
      bravais:=trimright(bravais);
//    if (systeme = 'RHOM')then bravais:='P';
      if (uppercase(groupe_espace) = 'FD3M')then bravais:='D';
      for i:=1 to 8 do begin
        if (bravais = bra[i]) then begin
          ibrav:=i;
          break;
        end;
      end;
    end;

//Titre}
    titre:=edit50.text;

//Lecture de la maille
    val(edit2.text,a,ier);
    val(edit3.text,b,ier);
    val(edit4.text,c,ier);
    val(edit5.text,alpha,ier);
    val(edit6.text,beta,ier);
    val(edit7.text,gamma,ier);
    if (a*b*c*alpha*beta*gamma = 0)then ier:=1;

//groupe d'espace
    test_groupe;

//Lecture donnes manip
    val(edit8.text,distance,ier);
    val(edit9.text,angle,ier);

    val(edit10.text,lambda_min,ier);
    val(edit11.text,lambda_max,ier);
    val(edit18.text,hauteur,ier);
    val(edit13.text,largeur,ier);

//gomtrie
    if(RadioGroup1.ItemIndex = 0)then geom:='FLAT';
    if(RadioGroup1.itemIndex = 1)then geom:='CYL';
    if (radioGroup1.itemindex = -1)then ier:=1;
    delta:=180-abs(angle);
    if(angle <> 0)then delta:=delta*abs(angle)/angle;
    codelta:=cos(delta/57.2957);
    sidelta:=sin(delta/57.2957);

    if (a*b*c*alpha*beta*gamma = 0) then exit;
    setmat;
  end;
end;

//Effacement image;
procedure efface_image;
//---------------------
begin
  with flimage1 do begin
    refresh;
    canvas.brush.color:=clwhite;
    canvas.rectangle(0,0,image1.width-1,image1.height-1);
    canvas.pen.color:=clblack;
    refresh;
  end;
end;

procedure reset_program;{
------------------------}
var i,j       : integer;
begin
  foemenu.rotation1.enabled:=false;
  foemenu.impression1.enabled:=false;
  foemenu.reorientation1.enabled:=false;
  foemenu.simulation1.enabled:=false;
  for i:=1 to 3 do begin
    for j:= 1 to 3 do begin
      r13[i,j]:=0;
      r31[i,j]:=0;
      r23[i,j]:=0;
      r32[i,j]:=0;
    end;
  end;
  message_matrice:='';
  message_groupe:='';
end;

{Item Exit}
procedure Tfoemenu.sortie(Sender: TObject);{
-------------------------------------------}
begin
  screen.onactiveformchange:=nil;
  application.helpCommand(HELP_QUIT,0);
  close;
end;

{Item Donnes/Ecran}
procedure Tfoemenu.Ecran1Click(Sender: TObject);{
------------------------------------------------}
begin
    nom_fichier_donnees:='';
    message_matrice:='';
    nsol:=0;
    no_sol:=0;
    //ecriture_panneaux(sender);
    save1.enabled:=true;
    panel1.visible:=true;
    panel6.visible:=true;
    panel1.height:=433;
end;

{Item Donnes/Fichier}
procedure Tfoemenu.Fichier1Click(Sender: TObject);{
--------------------------------------------------}

var
    nomf                                             : TextFile;
    i                                                : integer;
    delta                                            : real;
begin
  nb_pixel_cm:=29.5;
  nom_fichier_coord:='';
  nom_fichier_donnees:='';
  nom_fichier_image:='';
  message_matrice:='';
  OpenDialog1.filterIndex:=1;
  nsol:=0;
  if OpenDialog1.execute then
    nom_fichier_donnees:=OpenDialog1.filename;
  if length(nom_fichier_donnees) >0 then begin
    AssignFile(nomf,nom_fichier_donnees);
    reset(nomf);
    readln(nomf,titre);
    readln(nomf,systeme);        {Systeme}
    readln(nomf,bravais);
    readln(nomf,groupe_espace);
    readln(nomf,a,b,c,alpha,beta,gamma);
    readln(nomf,distance,angle);
    readln(nomf,lambda_min,lambda_max);
    readln(nomf,largeur,hauteur);
    readln(nomf,geom);
    closeFile(nomf);
    delta:=180-abs(angle);
    if(angle <> 0)then delta:=delta*abs(angle)/angle;
    codelta:=cos(delta/57.2957);
    sidelta:=sin(delta/57.2957);
    if(systeme = 'C')then systeme:='CUBI';
    if(systeme = 'Q')then systeme:='TETR';
    if(systeme = 'O')then systeme:='ORTH';
    if(systeme = 'H')then systeme:='HEXA';
    if(systeme = 'R')then systeme:='RHOM';
    if(systeme = 'M')then systeme:='MONO';
    if(systeme = 'T')then systeme:='TRIC';
    bravais:=uppercase(copy(groupe_espace,1,1));
    bravais:=trimright(bravais);
    if (systeme = 'RHOM')then bravais:='P';
    if (uppercase(groupe_espace) = 'FD3M')then bravais:='D';
    for i:=1 to 8 do begin
      if (bravais = bra[i]) then begin
        ibrav:=i;
        break;
      end;
    end;
    setmat;
    lecgroup;
    ecriture_panneaux(Sender);
    save1.enabled:=true;
  end else begin
     nom_fichier_donnees:='';
     ecriture_panneaux(sender);
  end;
  reset_program;
  panel6.visible:=false;
  if (systeme = 'HEXA') and (bravais = 'R')then begin
      fhexatorhomb.visible:=true;
      exit;
  end;
 end;

{Item matrice/Acquisition}
procedure Tfoemenu.Acquisition1Click(Sender: TObject);{
------------------------------------------------------}
begin
  flimat.visible:=true;
  nom_fichier_coord:='';
  nobs:=0;
  ns:=0;
  ecriture_panneaux(sender);
  message_matrice:='Matrix defined by the user';
end;

{Item Simulation/Ecran}
procedure Tfoemenu.simule_laue(Sender: TObject); {
-------------------------------------------------}
begin
  if (length(nom_fichier_image) = 0)then nb_pixel_cm:=29;
  type_diagramme:='laue';
  fdessin.visible:=true;
  restauration1.enabled:=true;
end;

{Item Matrice/Affichage}
{Item APropos}
procedure Tfoemenu.AproposClick(Sender: TObject);{
-------------------------------------------------}
begin
  fapropos.visible:=true;
end;

{Item Matrice/Rotation}
procedure Tfoemenu.Rotation1Click(Sender: TObject);{
---------------------------------------------------}
begin
   fmatrot.visible:=true;
   ecriture_panneaux(sender);
   restauration1.enabled:=true;
end;

procedure ecrit_transparent(var x,y: integer; var s:string);
//----------------------------------------------------------
var
  tmpF                 : HFONT;
  tmpL                 : TlogFont;
  //oldFont              : HFONT;
  tmpTFont             : TFont;
  //offsetX              : Integer;
begin
  tmpTFont:=TFont.Create;
  tmpTFont.Assign(foemenu.image2.canvas.font);
  GetObject(foemenu.image2.canvas.Font.Handle,SizeOf(TLogFont),@tmpL);
  //tmpL.lfEscapement:=900;
  //tmpL.lfOrientation:=900;
  tmpF:=CreateFontIndirect(tmpL);
  foemenu.image2.canvas.Font.Handle:=tmpF;
  setBkMode(foemenu.image2.canvas.Handle,TRANSPARENT );
  foemenu.image2.canvas.Textout(x,y,s);
  setBkMode(foemenu.image2.canvas.Handle, OPAQUE);
  foemenu.image2.canvas.Font.assign(tmpTFont);
  DeleteObject(tmpF);
  tmpTFont.Free;
end;

procedure dessin_solution;{
--------------------------}
var
  s                                                                  : string;
  xm,xn,ym,yn,xf,yf,wl,vv,rhkl,r2hkl,xx4,yy4,zz4,x3p,y3p,z3p,echel   : real;
  delta,{sidelta,codelta,}beta,diag,som,vc,xk,qm,angler,ah,ak,al       : real;
  x3,y3,z3,ang                                                ,q     : real;
  hmax,kmax,lmax,x,y,xo,yo,ih,ik,il,iext,i,j,k                       : integer;
  i_largeur,i_hauteur                                                : integer;
begin
    with foemenu.image2 do begin
      if (screen.width = 800)then begin
        width:=526;
        height:=333;
      end else begin
        width:=680;
        height:=430;
      end;
      i_largeur:=width;
      i_hauteur:=height;
    end;

    if (largeur > hauteur)then begin
      echel:=i_largeur/largeur;
      i_hauteur:=round(hauteur*echel);
    end else begin
      echel:=i_hauteur/hauteur;
      i_largeur:=round(largeur*echel);
    end;
    foemenu.image2.height:= round(hauteur*echel);
    if (screen.width = 800) and (i_hauteur > 333)then begin
        q:=333/i_hauteur;
        echel:=echel*q;
        i_hauteur:=333;
        i_largeur:=round(echel*largeur);
    end;
    if (screen.width > 800) and (i_hauteur > 433)then begin
        q:=433/i_hauteur;
        echel:=echel*q;
        i_hauteur:=433;
        i_largeur:=round(echel*largeur);
    end;

//Effacement de l'image
   with foemenu.image2 do begin
      canvas.brush.color:=clsilver;
      canvas.rectangle(0,0,width,height);
      Stretch := False;
   end;

//Une image est charge
  if (length(nom_fichier_image) > 0)then begin
    foemenu.image2.width:=i_largeur;
    foemenu.image2.height:=i_hauteur;

    echel:=nb_pixel_cm;
    xo:=x_origine;
    yo:=y_origine;
    with foemenu do begin
      Image2.Stretch := True;
      Image2.Picture.LoadFromFile(nom_fichier_image);
      ClipBoard.assign(image2.Picture);
      image2.picture.assign(clipboard);
      if (nobs > 0)then begin
        image2.canvas.font.name:='courier new';
        image2.canvas.font.height:=15;
        image2.canvas.font.color:=clred;
        for i:=1 to nobs do begin
          x:=xo+trunc(xobs[i]*echel);
          y:=yo-trunc(yobs[i]*echel);
          canvas.ellipse(x-3,y-3,x+3,y+3);
          s:=inttostr(i);
          j:=x+2;
          k:=y+2;
          ecrit_transparent(j,k,s);
        end;
        canvas.pen.color:=clblack;
        canvas.font.color:=clblack;
      end;
    end;
    
//pas d'image charge
  end else begin
    with foemenu.image2 do begin
      xo:=i_largeur div 2 ;
      yo:=i_hauteur div 2;
      //Stretch := false;
      canvas.brush.color:=clwhite;
      canvas.pen.color:=clblack;
      canvas.rectangle(0,0,i_largeur,i_hauteur);
      canvas.FloodFill(i_largeur div 2,i_hauteur div 2,clblack,fsborder);
    end;
  end;
 //if (no_sol > 0)or (message_matrice = 'Matrix defined by the user')then begin
 if (no_sol > 0) or (message_matrice <> '')then begin
  xm:=largeur-xo/echel;
  xn:=-xo/echel;
  ym:=yo/echel;
  yn:=-hauteur+yo/echel;
  diag:=sqrt(sqr(largeur)+sqr(hauteur))/2;
  with foemenu.image2 do begin
   if(geom = 'CYL') then begin
      beta:=diag/distance;
    end else begin
      beta:=atan2(diag,distance);
    end;
    angler:=angle/57.2957;
    som:=abs(angler)+beta*57.2957;
    if(som > 180) then som:=180;
    som:=som/(57.2957);

//Limitation du nombre de raies
    q:=a*b*c*sqrt(1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc);
    if (q > 10)then begin
     if(q < 0.0000001)then exit;
      vc:=1/q;
      xk:=2000*vc+1/fexp(lambda_max,3);
      xk:=1/xk;
      xk:=fexp(xk,0.3333333);
      qm:=2.*sin(som/2)/xk;
    end else begin
      qm:=2.*sin(som/2)/lambda_min;
    end;

//Indices max
    hmax:=round(qm*a);
    kmax:=round(qm*b);
    lmax:=round(qm*c);

//croix
    canvas.ellipse(xo-7,yo-7,xo+7,yo+7);
    canvas.moveto(xo-5,yo);
    canvas.lineto(xo+5,yo);
    canvas.moveto(xo,yo-5);
    canvas.lineto(xo,yo+5);

//Dessin des taches observes
    if(nobs <> 0)
    and (message_matrice <> 'Matrix before reorientation')
    and (message_matrice <> 'Orientation matrix after rotation')
    and (message_matrice <> 'Matrix defined by the user')
    and (message_matrice <> 'Orientation matrix after reorienting')
    and (message_matrice <>
    'Caution! The original matrix was modified. Use MATRIX+RESTORE to restore it.')
    then begin
      canvas.pen.color:=clred;
      if (nobs > 0) and (nom_fichier_image = '')then begin
        canvas.font.height:=15;
        canvas.font.name:='courier new';
        canvas.font.color:=clred;
        for i:=1 to nobs do begin
          x:=xo+trunc(xobs[i]*echel);
          y:=yo-trunc(yobs[i]*echel);
          canvas.ellipse(x-3,y-3,x+3,y+3);
          s:=inttostr(i);
          j:=x+2;
          k:=y+2;
          ecrit_transparent(j,k,s);
        end;
      end;
      canvas.pen.color:=clblack;
      canvas.font.color:=clblack;
    end;

//dessin des taches supplmentaires
    if (ns > 0)then begin
      canvas.pen.color:=clfuchsia;
      for i:=1 to ns do begin
        x:=xo+trunc(x_sup[i]*echel);
        y:=yo-trunc(y_sup[i]*echel);
        canvas.ellipse(x-3,y-3,x+3,y+3);
      end;
      canvas.pen.color:=clblack;
    end;

//Dessin des taches calcules
    nt:=0;
    iext:=0;
    canvas.brush.color:=claqua;
    if (nom_fichier_image <> '')then begin
      canvas.pen.color:=clred;
      canvas.brush.color:=clred;
    end;
    for ih:=-hmax to hmax do begin
      ah:=ih;
      for ik:=-kmax to kmax do begin
        ak:=ik;
        for il:=-lmax to lmax do begin
          al:=il;
          if(ih = 0) and (ik = 0) and (il = 0) then continue;
          extinc(ih,ik,il,iext);
          if(iext <> 0) then continue;
          x3:=r31[1,1]*ah+r31[1,2]*ak+r31[1,3]*al;
          if (x3 < 0.00001) then continue;
          y3:=r31[2,1]*ah+r31[2,2]*ak+r31[2,3]*al;
          z3:=r31[3,1]*ah+r31[3,2]*ak+r31[3,3]*al;
          r2hkl:=x3*x3+y3*y3+z3*z3;
          rhkl:=sqrt(r2hkl);
          if (rhkl > qm) then continue;
          wl:=2*x3/r2hkl;
          if (wl < lambda_min) or (wl > lambda_max) then continue;
          x3p:=x3*wl-1;
          y3p:=y3*wl;
          z3p:=z3*wl;
          xx4:=x3p*codelta-y3p*sidelta;
          if (abs(xx4) < 0.0001) then continue;
          yy4:=x3p*sidelta+y3p*codelta;
          zz4:=z3p;
          if (geom = 'CYL') then begin
            xf:=distance*arctan2(-yy4,xx4);
            yf:=zz4*distance/sqrt(xx4*xx4+yy4*yy4);
          end else begin
            vv:=distance/xx4;
            xf:=-vv*yy4;
            yf:=vv*zz4;
            if (xx4 <= 0) then continue
          end;
          if (yf >= Ym) or (yf <= yn) then continue;
          if (xf >= Xm) or (xf <= xn) then continue;
          x:=xo+trunc(xf*echel);
          y:=yo-trunc(yf*echel);
          canvas.ellipse(x-rayon_ellipse,y-rayon_ellipse,x+rayon_ellipse,y+rayon_ellipse);
        end;
      end;
    end;
    canvas.pen.color:=clblack;
    canvas.brush.color:=clwhite;
  end;
 end;
end;

{Ecrit les panneaux Donnes et Coordonnes}
procedure Tfoemenu.ecriture_panneaux(Sender: TObject);{
------------------------------------------------------}
var
  s1,s2,s3,s,s_listbox    : string;
  i,j,k ,ier              : integer;
begin
  Application.Onhint:=DisplayHint;
  if (message_matrice = 'Orientation matrix after reorienting')
     then  restauration1.enabled:=true;
  if (nom_fichier_donnees = '')then begin
     relit_data(ier);
     if (ier = 0)then panel2.visible:=true;
     edit59.text:='';
  end else begin

{*******************************Panneau 1 : Donnes**************************}
    panel1.visible:=true;
    panel2.visible:=true;
    edit59.text:=extractFilename(nom_fichier_donnees);
    str(a:7:3,s);
    edit2.text:=s;
    str(b:7:3,s);
    edit3.text:=s;
    str(c:7:3,s);
    edit4.text:=s;
    str(alpha:7:2,s);
    edit5.text:=s;
    str(beta:7:2,s);
    edit6.text:=s;
    str(gamma:7:2,s);
    edit7.text:=s;
    s:=copy(systeme,1,4);
    if (s ='CUBI')then listbox3.itemindex:=0;
    if (s ='QUAD')then listbox3.ItemIndex:=1;
    if (s ='ORTH')then listbox3.ItemIndex:=2;
    if (s ='HEXA')then listbox3.ItemIndex:=3;
    if (s ='RHOM')then listbox3.ItemIndex:=4;
    if (s ='MONO')then listbox3.ItemIndex:=5;
    if (s ='TRIC')then listbox3.ItemIndex:=6;
    s:=copy(bravais,1,1);

   {ecriture_groupes;}
    edit20.text:=groupe_espace;

    str(distance:6:2,s);
    edit8.text:=s;
    str(angle:6:2,s);
    edit9.text:=s;
    str(lambda_min:7:4,s);
    edit10.text:=s;
    str(lambda_max:7:4,s);
    edit11.text:=s;
    str(largeur:4:1,s);
    edit13.text:=s;
    str(hauteur:4:1,s);
    edit18.text:=s;
    if (nom_fichier_donnees = '')then
    edit59.visible:=false else edit59.visible:=true;

    if (geom = 'FLAT')then radiogroup1.itemIndex:=0;
    if (geom = 'CYL') then radiogroup1.ItemIndex:=1;
    //edit27.text:=geom;

  end;

{********************************Panneau 2 : Coordonnes***********************}
  if(nom_fichier_coord = '')and (nobs = 0) then begin
    panel2.visible:=false;
  end else begin
    foemenu.indexation1.enabled:=true;
    if (nom_fichier_coord <> '')then begin
      panel2.visible:=true;
      edit23.text:=extractfilename(nom_fichier_coord);
    end;

    {Eciture des titres dand StingGrid1 et purge}
    stringGrid1.colwidths[0]:=39-10;
    StringGrid1.colwidths[3]:=39+10;
    StringGrid1.cells[0,0]:='Nb.';
    StringGrid1.cells[1,0]:='X(Cm)';
    StringGrid1.cells[2,0]:='Y(Cm)';
    StringGrid1.cells[3,0]:='  h  k  l';
    for i:=1 to 10 do begin
      str(i:2,s1);
      StringGrid1.cells[0,i]:=s1;
      s1:='';
      StringGrid1.cells[1,i]:=s1;
      StringGrid1.cells[2,i]:=s1;
      StringGrid1.cells[3,i]:=s1;
    end;

    {Ecriture des coordonnes}
    for i:=1 to nobs do begin
      str(xobs[i]:6:2,s1);
      stringGrid1.Cells[1,i]:=s1;
      str(yobs[i]:6:2,s1);
      stringGrid1.Cells[2,i]:=s1;
      if (nsol >0) and (no_sol <> 0) then begin
        s1:='';
        s2:='';
        j:=ishkl[no_sol,i,1];
        str(j:3,s1);
        s2:=s2+s1;
        j:=ishkl[no_sol,i,2];
        str(j:3,s1);
        s2:=s2+s1;
        j:=ishkl[no_sol,i,3];
        str(j:3,s1);
        s2:=s2+s1;
        stringGrid1.Cells[3,i]:=s2;
      end;
      with stringgrid1 do cells[rowcount,colcount]:='*';
    end;
  end;

  {********************Panel 7:Ecriture des solutions***************************}

  if (nsol > 0)then begin
   panel7.visible:=true;
   listbox1.clear;
   s:='Nb.   resid.    ';
   for i:=1 to nobs do s:=s+'  h  k  l  ';
   listbox1.Items.add(s);
   s:=' ';
   listbox1.Items.add(s);

   for i:=1 to nsol do begin
     str(i:2,s);
     s_listbox:=s+'  (';

     {calcul des residus}
     {ii:=i;}
     {calc_residu_coord(ii);}
     str(residu_coord[i]:7:4,s1);

     s_listbox:=s_listbox+s1+') ';
     for j:=1 to nobs do begin
        k:=ishkl[i,j,1];
        str(k:3,s1);
        k:=ishkl[i,j,2];
        str(k:3,s2);
        k:=ishkl[i,j,3];
        str(k:3,s3);
        s:=s1+s2+s3;
        s_listbox:=s_listbox+' '+s;
      end;
      listbox1.items.add(s_listbox);
    end;
    Listbox1.ItemIndex:=no_sol+1;
    if (message_matrice = 'Orientation matrix after reorienting')then
    Listbox1.ItemIndex:=-1;

  end else begin
      panel7.visible:=false;
      panel0.visible:=false;
      panel9.visible:=false;
  end;

{***************panel 9: Dessin du diagramme **********************************}
  if (nsol > 0) or (message_matrice = 'Matrix defined by the user') or
  (message_matrice = 'Orientation matrix after rotation') or
  (message_matrice = 'Orientation matrix after reorienting')or
  (message_matrice = 'The original orientation matrix was restored')then begin
    panel0.visible:=true;
    if (systeme = 'RHOM') and (copy(groupe_espace,1,1)= 'R')then begin
      panel11.visible:=true;
      radiogroup2.itemindex:=1;
    end else panel11.visible:=false;
    for i:=1 to 3 do begin   //rciproque (r13 direct)
      for j:= 1 to 3 do begin
        str(r13[i,j]:9:5,s);
        StringGrid3.Cells[i-1,j-1]:=s;
      end;
    end;
    for i:=1 to 3 do begin   //direct (r31 transpose)
      for j:= 1 to 3 do begin
        str(r31[i,j]:9:6,s);
        StringGrid4.Cells[j-1,i-1]:=s;
      end;
    end;
    panel9.visible:=true;
    dessin_solution;
  end;

  if (nsol = 0) and (nom_fichier_image <> '') then begin
      panel9.visible:=true;
      dessin_solution;
  end;

{*****************************Panneau 4 : message matrice**********************}
  if(message_matrice = '')then begin
    panel4.visible:=false ;
    panel7.visible:=false;
    simulation1.enabled:=false;
    rotation1.enabled:=false;
    impression1.enabled:=false;
    reorientation1.enabled:=false;
  end else begin
    reorientation1.enabled:=true;
    panel4.visible:=true;
    panel4.caption:=message_matrice;
    simulation1.enabled:=true;
    rotation1.enabled:=true;
    impression1.enabled:=true;
    if(no_sol <> 0)then affinement1.enabled:=true;
  end;

//**********************Items menu*********************************************
  if (no_sol = 0) and (message_matrice = '') then begin
    reorientation1.enabled:=false;
    simulation1.enabled:=false;
  end else begin
    reorientation1.enabled:=true;
    simulation1.enabled:=true;
  end;
  if (message_matrice <> '')then simulation1.enabled:=true;
  relit_data(ier);
  if (ier = 1)then begin
    coordonnes1.enabled:=false;
    matrice1.enabled:=false;
    indexation1.enabled:=false;
    coordonnes1.enabled:=false;
    matrice1.enabled:=false;
    acquisition1.enabled:=false;
  end else begin
    coordonnes1.enabled:=true;
    matrice1.enabled:=true;
    acquisition1.enabled:=true;
  end;
  if (nobs > 0)then indexation1.enabled:=true else indexation1.enabled:=false;
  panel6.visible:=false;

 end;


{$i dfm_mainmenu.pas}

{Initialisation  la cration}
procedure Tfoemenu.Initialise_first(Sender: TObject);{
-----------------------------------------------------}
var
  s   : string;
begin
  GetDir(0,repertoire_origine);{ 0 = Current drive }
// Test d'existence des fichiers
  s:='';
  if fileExists('report.txt')then deletefile('report.txt');
  if (FileExists('orientExpress.hlp') = false)
   then s:='File OrientExpress.hlp does not exist!';
  if (FileExists('orientExpress.cnt') = false)
   then s:='File OrientExpress.cnt does not exist!';
  if (FileExists('orientExpress.grp') = false)
   then s:='File OrientExpress.grp does not exist!';
  if (length(s) > 0)then begin
    erreur(s);
    close;
    halt;
  end;

  top:=0;left:=0;
  rayon_ellipse:=2;
  flag_print:=0;
  updown_avant:=1;
  sample_ref:='';
  nom_fichier_donnees:='';
  nom_fichier_image:='';
  message_matrice:='';
  message_groupe:='';
  no_sol:=0;
  limite:=10;
  Application.Onhint:=DisplayHint;
  nom_fichier_image:='';
  panel1.height:=369;
  Application.HelpFile:='Orientexpress.hlp';
  if (screen.width = 800) then begin
    panel10.visible:=false;
    mainmenu800;
  end else panel10.visible:=true;
  panel10.left:=2;
  panel10.top:=2;
  panel1.left:=2;
  panel1.top:=186;
  panel6.left:=2;
  panel6.top:=534;
  panel2.left:=169;
  panel2.top:=186;

  panel0.left:=325;
  panel0.top:=2;
  panel7.left:=325;
  panel7.top:=113;
  panel7.width:=687;
  panel9.left:=325;
  panel9.top:=249;
  panel9.width:=687;
end;

{Ecriture d'aide des Items (proprit HINT)}
procedure Tfoemenu.DisplayHint (Sender: TObject);{
-------------------------------------------------}
begin
  panel3.Caption:=Application.Hint;
end;

{Item Rorientation}
procedure Tfoemenu.reorientation(Sender: TObject);{
--------------------------------------------------}
begin
   freorient.visible:=true;
end;

{Item Matrice/Imprime}
procedure Tfoemenu.Imprime_matrice(Sender: TObject);{
----------------------------------------------------}
Var
 //MyFile   : System.Text;
 MyFile   : TextFile;
 s        : String;
 i,j      : integer;
 aux      : matrice3;
 CmdFile  : Pchar;
begin
  Screen.cursor:=CrHourGlass;

//  if PrintDialog1.execute then begin
    AssignFile(MyFile,'print.txt');
    ReWrite(MyFile);
    Printer.canvas.font.size:=8;
    s:=DateTimeToStr(Now);
    writeln(MyFile,s);
    s:= titre;
    writeln(MyFile,s);
    writeln(MyFile);

    writeln(Myfile,
    '                               Orientation Matrix');
    writeln(MyFile);
    writeln(MyFile,'Reciprocal space');
    writeln(MyFile);
    Write(MyFile,'Crystal axis // to the beam axis      (OX) : ');
    for i:=1 to 3 do write(MyFile,r13[i,1]:11:6);
    Writeln(Myfile);
    Write(MyFile,'                                      (OY) : ');
    for i:=1 to 3 do write(MyFile,r13[i,2]:11:6);
    Writeln(Myfile);
    Write(MyFile,'Crystal axis // to the camera axis    (OZ) : ');
    for i:=1 to 3 do write(MyFile,r13[i,3]:11:6);
    Writeln(Myfile);

    writeln(MyFile);
    writeln(MyFile);
    writeln(MyFile,'Direct space');
    writeln(MyFile);
    Write(MyFile,'Crystal axis // to the beam axis      (OX) : ');
    for i:=1 to 3 do write(MyFile,r31[1,i]:11:6);
    writeln(MyFile);
    Write(MyFile,'                                      (OY) : ');
    for i:=1 to 3 do write(MyFile,r31[2,i]:11:6);
    writeln(MyFile);
    Write(MyFile,'Crystal axis // to the camera axis    (OZ) : ');
    for i:=1 to 3 do write(MyFile,r31[3,i]:11:6);
    writeln(MyFile);

    Writeln(Myfile);
    Writeln(Myfile);
    writeln(MyFile);
    for i:=1 to 3 do begin
      aux[2,i]:=-r31[1,i];
      aux[1,i]:=r31[2,i];
      aux[3,i]:=r31[3,i];
    end;
    writeln(MyFile,
    '         Direct matrix(R13)                   Reciprocal matrix(R31)');
    writeln(MyFile);
    for i:=1 to 3 do begin
      for j:=1 to 3 do write(MyFile,r13[i,j]:11:6);
      write(Myfile,'     ');
      for j:=1 to 3 do write(MyFile,r31[i,j]:11:6);
      writeln(MyFile);
    end;
    writeln(myfile);
    writeln(myfile);
    writeln(MyFile,
    '            ENRAF-NONIUS                          BUSING-LEVY');
    writeln(MyFile);
    for i:=1 to 3 do begin
      for j:=1 to 3 do write(MyFile,r31[i,j]:11:6);
      write(Myfile,'     ');
      for j:=1 to 3 do write(MyFile,aux[i,j]:11:6);
      writeln(MyFile);
    end;
    System.Close(Myfile);
    Screen.cursor:=CrDefault;
 //end;
  Cmdfile:='write.exe print.txt';
  i:=winExec(CmdFile,5);

 end;

{Item Simualtion/Stro}
procedure Tfoemenu.simule_stereo(Sender: TObject);{
--------------------------------------------------}
begin
  type_diagramme:='stereo';
  fdessin.visible:=true;
end;

procedure Tfoemenu.editeur(Sender: TObject);{
---------------------------------------------}
Var
  i        : integer;
  CmdFile  : Pchar;
begin
  Cmdfile:='Notepad.exe';
  i:=winExec(CmdFile,5);
end;

(*----------------------------------Coordonnes-------------------------------*)

procedure Tfoemenu.coordon_fichier(Sender: TObject);{
-------------------------------------------------------}
var
  nomf           : TextFile;
  x,y            : single;
begin
   entree_coordonnees(sender);
   type_coordon:=1;
   clipboard.clear;
   nom_fichier_image:='';
   message_matrice:='';
   if(nom_fichier_image <> '')then begin
     clipboard.clear;
     nom_fichier_image:= '';
   end;
   OpenDialog1.filterIndex:=2;
   x_origine:=0;
   y_origine:=0;
   if OpenDialog1.execute then
     nom_fichier_coord:=OpenDialog1.filename;

   if (length(nom_fichier_coord) > 0 )then begin
     assignFile(nomf,nom_fichier_coord);
     reset(nomf);
     nobs:=0;
     no_sol:=0;
     nsol:=0;
     ns:=0;
     while not(eof(nomf)) do begin
       readln(nomf,x,y);
       if(x = 0) and (y = 0)then  break;
       nobs:=nobs+1;
       xobs[nobs]:=x;
       yobs[nobs]:=y;
     end;
     CloseFile(nomf);
     coordlist1.enabled:=true;

     message_matrice:='';
     ecriture_panneaux(Sender);
   end;
   if(nom_fichier_coord <> '')then foemenu.indexation1.enabled:=true;
end;

procedure Tfoemenu.coordon_clavier(Sender: TObject);{
-----------------------------------------------------}
begin
  type_coordon:=0;
  clipboard.clear;
  x_origine:=0;
  y_origine:=0;
  fcoordon.visible:=true;
  coordlist1.visible:=true;
  message_matrice:='';
  nom_fichier_image:='';
  if(nom_fichier_image <> '')then begin
     clipboard.clear;
     nom_fichier_image:= '';
  end;
end;

procedure Tfoemenu.modif_coordonnees(Sender: TObject);{
------------------------------------------------------}
begin
  if(nobs = 0)then begin
    erreur('No coordinates');
    exit;
  end;
  type_coordon:=-1;
  fcoordon.visible:=true;
end;

procedure Tfoemenu.coordon_scanner(Sender: TObject);{
-----------------------------------------------------}
begin
  type_coordon:=2;
  no_sol:=0;
  nsol:=0;
  ns:=0;
  nom_fichier_coord:='';
  no_appel:=1;
  flimage1.visible:=true;
end;

procedure Tfoemenu.lecture_coordonnees(Sender: TObject);{
--------------------------------------------------------}
var
   s             : string;
   ier,i         : integer;
   xx,yy         : real;
   sortie        : TextFile;
begin
  nobs:=0;
  ns:=0;
  nsol:=0;
  for i:=1 to 10 do begin
    s:=stringGrid1.cells[1,i];
    if (s = '') then s:='0';
    val(s,xx,ier);
    if (ier > 0)then begin
      erreur('Erreur  la ligne '+inttostr(i));
      exit;
    end;
    s:=StringGrid1.cells[2,i];
    if (s = '') then s:='0';
    val(s,yy,ier);
    if (ier > 0)then begin
      erreur('Erreur  la ligne '+inttostr(i));
      exit;
    end;
    stringgrid1.cells[3,i]:='';
    if (s = '') then s:='0';
    if( xx = 0) and (yy = 0) then break;
    nobs:=nobs+1;
    xobs[nobs]:=xx;
    yobs[nobs]:=yy;
  end;

  {Sauvegarde?}
  s:=edit23.text;
  if (length(s) > 0)then begin
    if (pos ('.coo',s) = 0)then  nom_fichier_coord:=edit23.text+'.coo'
    else  nom_fichier_coord:=edit23.text;
    AssignFile(sortie,nom_fichier_coord);
    ReWrite(sortie);
    for i:=1 to nobs do writeln(sortie,xobs[i]:10:5,yobs[i]:10:5);
    closeFile(sortie);
  end;
end;

(*---------------------------fin coordonnes---------------------------------*)

procedure Tfoemenu.calcul(Sender: TObject);{
-------------------------------------------}
begin
   ns:=0;
   relit_data(ier);
   if (ier > 0)then begin
     erreur('Data error');
     exit;
   end;
   fcalcul.visible:=true;
end;

procedure Tfoemenu.restaure_matrice(Sender: TObject);{
-----------------------------------------------------}
begin
  ident(r13_old,r13);
  matinv(r13,r31);
  mat_mult(r31,r12,r32);
  matinv(r32,r23);
  message_matrice:='The original orientation matrix was restored';
  ecriture_panneaux(sender);
end;

procedure Tfoemenu.afine_vectoriel(Sender: TObject);{
----------------------------------------------------}
var
  i  : integer;
begin
 (*if (type_coordon < 2)then begin
   ns:=0;
   for i:=1 to 30 do begin
     x_sup[i]:=0;
     y_sup[i]:=0;
   end;
   faffivec2.visible:=true;
   exit;
 end;  *)
 if (no_sol = 0) or (nsol = 0)then exit;
 faffivec1.visible:=true;
end;

procedure Tfoemenu.dispal_solution(Sender: TObject);{
----------------------------------------------------}
begin
  {fdispsol.visible:=true;}
end;

procedure Tfoemenu.Affiche_aide(Sender: TObject);{
-------------------------------------------------}
begin
   Application.HelpFile:=repertoire_origine+'\OrientExpress.hlp';
   Application.HelpContext(4);
end;

procedure Tfoemenu.selecte_solution(Sender: TObject);{
-----------------------------------------------------}
var
  s   : string;
begin
  if (ListBox1.ItemIndex < 2 ) or (listBox1.ItemIndex > nsol+1) then exit;
  no_sol:=Listbox1.ItemIndex-1;
  afine_mat;
  str(no_sol:2,s);
  message_matrice:='The solution Nb.'+s+' is loaded';
  ecriture_panneaux(sender);
end;
procedure Tfoemenu.help_general(Sender: TObject);{
-------------------------------------------------}
begin
   Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(1);
end;

(*procedure Tfoemenu.ajuste_rayon(Sender: TObject; var AllowChange: Boolean);{
---------------------------------------------------------------------------}
var
  dif  : integer;
begin
 dif:=updown1.position-updown_avant;
 if (dif = 0)then exit;
 rayon_ellipse:=rayon_ellipse+(abs(dif) div dif);
 updown_avant:=updown1.position;
 dessin_solution;
end;    *)

procedure Tfoemenu.simule_stereon(Sender: TObject);{
---------------------------------------------------}
begin
  {fpstereo.visible:=true;}
end;

procedure Tfoemenu.change_rayon(Sender: TObject; Button: TUDBtnType);{
---------------------------------------------------------------------}
var
  dif  : integer;
begin
 dif:=updown1.position-updown_avant;
 if (dif = 0)then exit;
 rayon_ellipse:=rayon_ellipse+(abs(dif) div dif);
 updown_avant:=updown1.position;
 dessin_solution;
end;

procedure Tfoemenu.sauve_donnees(Sender: TObject);{
--------------------------------------------------}
var
  nomf   : TextFile;
  s      : string;
  w      : word;
  ier    : integer;
begin
  relit_data(ier);
  if (ier > 0)then exit;
  SaveDialog1.filterIndex:=1;
  if SaveDialog1.execute then begin
    s:=SaveDialog1.filename;
    if (pos('.dat',s)=0)then s:=s+'.dat';
    if FileExists(s) then begin
      //beep;
      w:=messageDlg('This file already exists. Do you want to continue?',
      mtConfirmation,mbYesNoCancel,0);
      if (w = mrNo) or (w = mrAbort) then exit;
    end;
    nom_fichier_donnees:=s;
  end else begin
    exit;
  end;

  {Ecriture du fichier de sortie}
  AssignFile(nomf,nom_fichier_donnees);
  Rewrite(nomf);
  writeln(nomf,titre);
  writeln(nomf,systeme);
  writeln(nomf,bravais);

 {Ecriture du groupe d'espace}
  writeln(nomf,groupe_espace);

  {Reste}
  writeln(nomf,a:8:3,b:8:3,c:8:3,alpha:8:2,beta:8:2,gamma:8:2);
  writeln(nomf,distance:8:2,angle:9:3);
  writeln(nomf,lambda_min:8:4,lambda_max:8:4);
  writeln(nomf,largeur:8:2,hauteur:8:2);
  writeln(nomf,geom);
  closefile(nomf);
  valide_data(sender);
//  ecriture_panneaux(Sender);
end;

// modification des constantes image
procedure Tfoemenu.Imageconst1Click(Sender: TObject);{
-----------------------------------------------------}
begin
  if (nom_fichier_image = '')then begin
    erreur('No image loaded!');
    exit;
  end;
  fmodifimage.visible:=true;
end;

procedure Tfoemenu.coordon_digitaliseur(Sender: TObject);{
---------------------------------------------------------}
begin
  nobs:=0;
  type_coordon:=3;
  fdigital.visible:=true;
end;

procedure Tfoemenu.degrade_form1(Sender: TObject);
//------------------------------------------------
var
 i1,i2    : integer;
 FDegrade : TDegradeClass;
begin
    FDegrade:=TDegradeClass.Create;
    i1:=$ff0000;
    i2:=$FFDAD0;
    fdegrade.Graduate(self,i1,i2);
end;

procedure Tfoemenu.verif_groupe(Sender: TObject);
//-----------------------------------------------
var
  Nomf                        : TextFile;
  s,groupe                    : string;

begin
  test_groupe;
end;

procedure Tfoemenu.no_entree(Sender: TObject);
//-------------------------------------------
begin
  edit59.text:='';
  if (fcalcul.visible = true) then fcalcul.visible:=false;
  if (message_matrice <> '')then begin
    panel7.visible:=false;
    panel0.visible:=false;
    panel9.visible:=false;
  end;
  if(edit2.focused) then no_case:=1;   {a}
  if(edit3.focused) then no_case:=2;   {b}
  if(edit4.focused) then no_case:=3;   {c}
  if(edit5.focused) then no_case:=4;   {alpha}
  if(edit6.focused) then no_case:=5;   {beta}
  if(edit7.focused) then no_case:=6;   {gamma}
  if(edit8.focused) then no_case:=7;   {distance}
  if(edit9.focused) then no_case:=8;   {angle}
  if(edit10.focused) then no_case:=9;  {lbd1}
  if(edit11.focused) then no_case:=10; {lbd2}
  if(edit18.focused) then no_case:=11; {hauteur}
  if(edit13.focused) then no_case:=12; {largeur}
end;

procedure Tfoemenu.lit_case(Sender: TObject);
//-------------------------------------------
var
   ier                 : integer;
begin
  case no_case of

  1: begin
       if (edit2.text = '') then exit;
       val(edit2.text,a,ier);
       if(ier > 0)then begin
         Erreur('Error on a value!');
         edit2.setfocus;
         exit;
       end;
       if (systeme = 'CUBI') or (systeme = 'RHOM') then begin
         edit3.text:=edit2.text;
         edit4.text:=edit2.text;
       end;
       if (systeme = 'QUAD') or (systeme = 'TETRA') or (systeme = 'HEXA') then
       edit3.text:=edit2.text;
     end;

  2: begin
       if (edit3.text = '') then exit;
       val(edit3.text,b,ier);
       if(ier > 0)then begin
         Erreur('Error on b value!');
         edit3.setfocus;
         exit;
       end;
     end;
  3: begin
       if (edit4.text = '') then exit;
       val(edit4.text,c,ier);
       if(ier > 0)then begin
         Erreur('Error on c value!');
         edit4.setfocus;
         exit;
       end;
     end;
  4: begin
       if (edit5.text = '') then exit;
       val(edit5.text,alpha,ier);
       if(ier > 0)then begin
         Erreur('Error on alpha value!');
         edit5.setfocus;
         exit;
       end;
       if (systeme = 'RHOM')then begin
         edit6.text:=edit5.text;
         edit7.text:=edit5.text;
       end;
     end;
  5: begin
       if (edit6.text = '') then exit;
       val(edit6.text,b,ier);
       if(ier > 0)then begin
         Erreur('Error on beta value!');
         edit6.setfocus;
         exit;
       end;
     end;
  6: begin
       if (edit7.text = '') then exit;
       val(edit7.text,gamma,ier);
       if(ier > 0)then begin
         Erreur('Error on gamma value!');
         edit7.setfocus;
         exit;
       end;
     end;
  7: begin
       if (edit8.text = '') then exit;
       val(edit8.text,distance,ier);
       if(ier > 0)then begin
         Erreur('Error on distance value!');
         edit8.setfocus;
         exit;
       end;
     end;
  8: begin
      { val(edit9.text,angle,ier);
       if(ier > 0)then begin
         Erreur('Erreur d''criture sur l''angle!');
         edit9.setfocus;
         exit;
       end;}
     end;
  9: begin
       if (edit10.text = '') then exit;
       val(edit10.text,lambda_min,ier);
       if(ier > 0)then begin
         Erreur('Error on Lambda Min value!');
         edit10.setfocus;
         exit;
       end;
     end;
  10: begin
       if (edit11.text = '') then exit;
       val(edit11.text,lambda_max,ier);
       if(ier > 0)then begin
         Erreur('Error on Lambda Max value!');
         edit11.setfocus;
         exit;
       end;
     end;
  11: begin
       if (edit18.text = '') then exit;
       val(edit18.text,hauteur,ier);
       if(ier > 0)then begin
         Erreur('Erron height value!');
         edit18.setfocus;
         exit;
       end;
     end;
  12: begin
       if (edit13.text = '') then exit;
       val(edit13.text,largeur,ier);
       if(ier > 0)then begin
         Erreur('Error on width value!');
         edit13.setfocus;
         exit;
       end;
     end;

  end;
end;

procedure Tfoemenu.ListBox3Click(Sender: TObject);
//------------------------------------------------
var
  x,ar,alfa,ah,ch    : real;
  s                  : string;
begin
  edit2.color:=clwhite;
  edit3.color:=clwhite;
  edit4.color:=clwhite;
  edit5.color:=clwhite;
  edit6.color:=clwhite;
  edit7.color:=clwhite;
  edit2.readonly:=false;
  edit3.readonly:=false;
  edit4.readonly:=false;
  edit5.readonly:=false;
  edit6.readonly:=false;
  edit7.readonly:=false;
  case listbox3.ItemIndex of
    0 : begin
          systeme:='CUBI';
          edit3.color:=clsilver;
          edit4.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit4.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then begin
          edit3.text:=edit2.text;
          edit4.text:=edit2.text;
          end;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
          edit20.text:='Pm3';
        end;
    1 : begin
          systeme:='QUAD';
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then edit3.text:=edit2.text;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
          edit20.text:='P4/m';
        end;
    2 : begin
          systeme:='ORTH';
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='90';
          edit20.text:='Pmmm';
        end;
    3 : begin
          edit5.text:='90';
          edit6.text:='90';
          edit7.text:='120';
          edit20.text:='P6/m';
          if (systeme = 'RHOM') and (copy(groupe_espace,1,1) = 'R') and
          (a > 0) and (alpha > 0)then begin
            x:=sin(alpha/114.591559);
            ah:=2*a*x;
            ch:=ah*sqrt((9/(4*x*x))-3);
            str(ah:8:4,s);
            edit2.text:=s;
            str(ch:8:4,s);
            edit4.text:=s;
            systeme:='HEXA';
            a:=ah;
            b:=a;
            c:=ch;
            edit20.text:=groupe_espace;
          end;
          systeme:='HEXA';
          edit3.color:=clsilver;
          edit5.color:=clsilver;
          edit6.color:=clsilver;
          edit7.color:=clsilver;
          edit3.readonly:=true;
          edit5.readonly:=true;
          edit6.readonly:=true;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then edit3.text:=edit2.text;
        end;
    4 : begin
          edit5.text:='';
          edit6.text:='';
          edit7.text:='';
          edit20.text:='R-3';
          if (systeme ='HEXA') and (copy(groupe_espace,1,1) = 'R')
          and (a > 0) and (c > 0)then begin
            edit20.text:=groupe_espace;
            x:=sqrt(3+sqr(c/a));
            ar:=a*x/3;
            alfa:=2*57.29578*arcsin(3/(2*x));
            str(ar:7:3,s);
            edit2.text:=s;
            str(alfa:7:3,s);
            edit5.text:=s;
            edit6.text:=s;
            edit7.text:=s;
            a:=ar;b:=ar;c:=ar;alfa:=alpha;beta:=alpha;gamma:=alpha;
          end;
          systeme:='RHOM';
          edit3.color:=clsilver;
          edit3.readonly:=true;
          edit4.color:=clsilver;
          edit4.readonly:=true;
          edit6.color:=clsilver;
          edit6.readonly:=true;
          edit7.color:=clsilver;
          edit7.readonly:=true;
          if(length(edit2.text) > 0)then begin
            edit3.text:=edit2.text;
            edit4.text:=edit2.text;
          end;

        end;
    5 : begin
          systeme:='MONO';
          edit5.color:=clsilver;
          edit7.color:=clsilver;
          edit5.readonly:=true;
          edit7.readonly:=true;
          edit5.text:='90';
          edit7.text:='90';
          edit6.text:='';
          edit20.text:='P2/m';
        end;
    6 : begin
          systeme:='TRIC';
          edit2.text:='';
          edit3.text:='';
          edit4.text:='';
          edit5.text:='';
          edit6.text:='';
          edit7.text:='';
          edit20.text:='P-1';
        end;
  end;
  panel6.visible:=true;
end;

procedure Tfoemenu.abandon_donnees(Sender: TObject);
//-------------------------------------------------
begin
  panel1.height:=369;
  panel1.visible:=false;
end;

procedure Tfoemenu.valide_data(Sender: TObject);
//-----------------------------------------------
var
  ier               : integer;
  w                 : word;
begin
  relit_data(ier);
  if (ier > 0)then begin
    erreur('data error');
    exit;
  end;
  panel1.height:=369;
  panel2.visible:=true;
  coordonnes1.enabled:=true;
  save1.enabled:=true;
  ecriture_panneaux(Sender);
  panel6.visible:=false;
  w:=messageDlg('Do you want to save the data?',
  mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;
  sauve_donnees(Sender);
  if (systeme = 'HEXA') and (bravais = 'R')then begin
    fhexatorhomb.visible:=true;
    exit;
  end;
end;

procedure Tfoemenu.entree_coordonnees(Sender: TObject);
//----------------------------------------------------
begin
  relit_data(ier);
  if (ier > 0)then begin
    erreur('data error');
    exit;
  end;
end;

procedure Tfoemenu.sortie_distance(Sender: TObject);
//--------------------------------------------------
var
  ier         : integer;
begin
  relit_data(ier);
  ecriture_panneaux(sender);
end;

procedure Tfoemenu.cancel_redraw(Sender: TObject);
//------------------------------------------------
begin
  panel6.visible:=false;
end;

procedure Tfoemenu.ok_redraw(Sender: TObject);
//--------------------------------------------
begin
  if (message_matrice <> '')then begin
    panel7.visible:=true;
    if (screen.width > 800)then panel10.visible:=true;
    panel9.visible:=true;
  end;
  panel6.visible:=false;
  relit_data(ier);
  if (ier > 0)then exit;
  ecriture_panneaux(sender);
end;

procedure Tfoemenu.peint_cellule1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//--------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure premier2(var ih,ik,il:integer);
//---------------------------------------
{Rduction des indices de Miller  3 nombres premiers}
var
  i,j,mini,ipgcd                :integer;
  ni                            :array[1..3] of integer;

 begin
      ipgcd:=1;
      ni[1]:=ih;
      ni[2]:=ik;
      ni[3]:=il;
      mini:=1000;
      for i:=1 to 3 do begin
        if(ni[i] = 0) then continue;
        j:=abs(ni[i]);
        if(j < mini)then mini:=j;
      end;
      if(mini > 1)then begin
        for j:=mini downto 2 do begin
          if(ni[1] Mod j <> 0)then continue;
          if(ni[2] Mod j <> 0)then continue;
          if(ni[3] Mod j <> 0)then continue;
          ih:=ih div j;
          ik:=ik div j;
          il:=il div j;
          ipgcd:=j;
          exit;
        end;
      end;
 end;

procedure Tfoemenu.toto(Sender: TObject);
//---------------------------------------
begin
   //Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(8);
end;

//transformation R to H    (Gestion de la bascule H/R)
procedure Tfoemenu.reecrit_solutions(Sender: TObject);
//---------------------------------------------------
var
  s1,s2,s3,s,s_listbox              : string;
  i,j,h,k,l,ih,ik,il,isol           : integer;
  m,r31p,r13p                       : matrice3;
begin
   if (message_matrice = '')then exit;
   listbox1.clear;
   s:='Nb.   resid.    ';
   for i:=1 to nobs do s:=s+'  h  k  l  ';
   listbox1.Items.add(s);
   s:=' ';
   listbox1.Items.add(s);

   for i:=1 to nsol do begin
     str(i:2,s);
     s_listbox:=s+'  (';

{calc_residu_coord(ii);}
     str(residu_coord[i]:7:4,s1);

     s_listbox:=s_listbox+s1+') ';
//Affichage liste des solutions
     if (radiogroup2.itemindex = 1)then begin
        for j:=1 to nobs do begin
          k:=ishkl[i,j,1];
          str(k:3,s1);
          k:=ishkl[i,j,2];
          str(k:3,s2);
          k:=ishkl[i,j,3];
          str(k:3,s3);
          s:=s1+s2+s3;
          s_listbox:=s_listbox+' '+s;
        end;
      end else begin
      for j:=1 to nobs do begin
          ih:=ishkl[i,j,1];
          ik:=ishkl[i,j,2];
          il:=ishkl[i,j,3];
          h:=ih-ik;
          k:=ik-il;
          l:=ih+ik+il;
          premier2(h,k,l);
          str(h:3,s1);
          str(k:3,s2);
          str(l:3,s3);
          s:=s1+s2+s3;
          s_listbox:=s_listbox+' '+s;
       end;
     end;
     listbox1.items.add(s_listbox);
   end;

//Affichage des matrices
     if (radiogroup2.itemindex = 0)then begin
       m[1,1]:=2;m[1,2]:=1;m[1,3]:=1;
       m[2,1]:=-1;m[2,2]:=1;m[2,3]:=1;
       m[3,1]:=-1;m[3,2]:=-2;m[3,3]:=1;
       for i:=1 to 3 do
       for j:=1 to 3 do m[i,j]:=m[i,j]/3;
       mat_mult(r31,m,r31p);
       matinv(r31p,r13p);
       for i:=1 to 3 do begin   //rciproque (r13 direct)
         for j:= 1 to 3 do begin
           str(r13p[i,j]:9:5,s);
           StringGrid3.Cells[i-1,j-1]:=s;
         end;
       end;
       for i:=1 to 3 do begin   //direct (r31 transpose)
         for j:= 1 to 3 do begin
           str(r31p[i,j]:9:6,s);
           StringGrid4.Cells[j-1,i-1]:=s;
         end;
       end;

     end else begin
       for i:=1 to 3 do begin   //rciproque (r13 direct)
         for j:= 1 to 3 do begin
           str(r13[i,j]:9:5,s);
           StringGrid3.Cells[i-1,j-1]:=s;
         end;
       end;
       for i:=1 to 3 do begin   //direct (r31 transpose)
         for j:= 1 to 3 do begin
           str(r31[i,j]:9:6,s);
           StringGrid4.Cells[j-1,i-1]:=s;
         end;
       end;
     end;

//Affichage des indices de la solution slctionne
    if (radiogroup2.itemindex = 1)then begin
        for j:=1 to nobs do begin
          k:=ishkl[no_sol,j,1];
          str(k:3,s1);
          k:=ishkl[no_sol,j,2];
          str(k:3,s2);
          k:=ishkl[no_sol,j,3];
          str(k:3,s3);
          s:=s1+s2+s3;
          stringgrid1.Cells[3,j]:=s;
          s_listbox:=s_listbox+' '+s;
        end;
      end else begin
      for j:=1 to nobs do begin
          ih:=ishkl[no_sol,j,1];
          ik:=ishkl[no_sol,j,2];
          il:=ishkl[no_sol,j,3];
          h:=ih-ik;
          k:=ik-il;
          l:=ih+ik+il;
          premier2(h,k,l);
          str(h:3,s1);
          str(k:3,s2);
          str(l:3,s3);
          s:=s1+s2+s3;
          stringgrid1.Cells[3,j]:=s;
          s_listbox:=s_listbox+' '+s;
       end;
     end;
     listbox1.itemindex:=no_sol+1;
end;

procedure Tfoemenu.voir_panel6(Sender: TObject);
//----------------------------------------------
begin
  panel6.visible:=true;
end;


end.
